#ifndef CONSTANTS_H
#define CONSTANTS_H

using namespace std ;
#include <vector>
#include <iostream>
#include <cmath>

#define SIZE_PLANCHE 512
#define EPSILON 1e-15
#define SIZE_IMAGE_REPARTITION_X 256
#define SIZE_IMAGE_REPARTITION_Y 100
#define MASK_BYTE 255

#define PII 3.141592653589793238462
#define HALF_PI 1.5707963267949
#define INV_PI 0.31830988618379
#define IRAND 1.0 / RAND_MAX

#define INF_VALUE 0.004
#define SUP_VALUE 0.996

#include "parallelogramme.h"
//class parallelogramme ;

typedef vector<parallelogramme> paralleVector ;

typedef struct
    {
      int nbColors ;
      unsigned int* colors ;
} paletteRGB ;

typedef struct
    {
      int minZoomed ;
      int maxZoomed ;
      int low ;
      int high ;
      int sizeTable ;
      //int minValue ;
      int maxValue ;
      int* table ;
} parameterColoration ;

enum algorithmColoration
{
 ALGORITHM_COLORATION_ID_REPARTITION,
 ALGORITHM_COLORATION_ID_SIGMA
} ;

enum formatID
{
 FORMAT_ID_VIDEOSCAPE,
 FORMAT_ID_SGML,
 FORMAT_ID_POV_RAY,
 FORMAT_ID_RIB,
 FORMAT_ID_BLENDER
} ;

enum transformationID
{
 TRANSFORMATION_ID_TRANSLATION,
 TRANSFORMATION_ID_ROTATION,
 TRANSFORMATION_ID_SCALE,
 TRANSFORMATION_ID_CLIPPING,
 TRANSFORMATION_ID_SIMILARITY,
 TRANSFORMATION_ID_ANNUL
} ;

#define SIZE_128 128
#define SIZE_256 256
#define SIZE_512 512
#define SIZE_1024 1024
#define SIZE_2048 2048
#define SIZE_4096 4096
#define SIZE_8192 8196
#define SIZE_16384 16384

enum colorationBorderID
{
 SATURED_ID=0,
 MODULO_ID=1,
 CYCLE_ID=2,
 DARK_ID=3,
 BRIGHT_ID=4
} ;

enum sizeID
{
 SIZE_ID_128,
 SIZE_ID_256,
 SIZE_ID_512,
 SIZE_ID_1024,
 SIZE_ID_2048,
 SIZE_ID_4096,
 SIZE_ID_8192,
 SIZE_ID_16384,
 SIZE_ID_32768,
 SIZE_ID_65536
} ;

enum effectID
{
 EFFECT_ID_NONE,
 EFFECT_ID_SLIP,
 EFFECT_ID_COMPLEX,
 EFFECT_ID_V1,
 EFFECT_ID_V2,
 EFFECT_ID_V3,
 EFFECT_ID_V4,
 EFFECT_ID_V5,
 EFFECT_ID_V6,
 EFFECT_ID_V7,
 EFFECT_ID_V8,
 EFFECT_ID_V9,
 EFFECT_ID_V10,
 EFFECT_ID_V11,
 EFFECT_ID_V12,
 EFFECT_ID_V13,
 EFFECT_ID_W1,
 EFFECT_ID_W2,
 EFFECT_ID_W3,
 EFFECT_ID_W4,
 EFFECT_ID_W5,
 EFFECT_ID_W6,
 EFFECT_ID_W7,
 EFFECT_ID_W8,
 EFFECT_ID_W9,
 EFFECT_ID_W10,
 EFFECT_ID_W11,
 EFFECT_ID_W12,
 EFFECT_ID_W13,
 EFFECT_ID_GENERAL,
} ;

enum effectColorID
{
 EFFECT_COLOR_ID_NONE=0,
 EFFECT_COLOR_ID_LOG=1,
 EFFECT_COLOR_ID_GAMMA=2,
 EFFECT_COLOR_ID_RELIEF=3,
 EFFECT_COLOR_ID_CONTRAST=4
} ;

enum sommetID
{
 A_ID,
 B_ID,
 C_ID,
 D_ID,
 NONE_ID 
} ;



#endif


