//#include <iostream>
//#include <fstream>
//using namespace std ;

#include <qvariant.h>
#include <qlineedit.h>
#include <qlabel.h>
#include <qbuttongroup.h>
#include <qpushbutton.h>
#include <qradiobutton.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qcombobox.h>

#include "constants.h"
#include "dialog3D.h"


dialog3D :: dialog3D( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{

    setName( "dialog3D" );
    setSizeGripEnabled( TRUE );

    textLabel1 = new QLabel( this, "textLabel1" );
    textLabel1->setGeometry( QRect( 10, 20, 40, 20 ) );

    textLabel2 = new QLabel( this, "textLabel2" );
    textLabel2->setGeometry( QRect( 10, 50, 44, 20 ) );

    textLabel3 = new QLabel( this, "textLabel3" );
    textLabel3->setGeometry( QRect( 10, 80, 40, 20 ) );

    textLabel4 = new QLabel( this, "textLabel4" );
    textLabel4->setGeometry( QRect( 10, 110, 44, 20 ) );

    textLabel5 = new QLabel( this, "textLabel5" );
    textLabel5->setGeometry( QRect( 10, 140, 40, 20 ) );

    textLabel6 = new QLabel( this, "textLabel6" );
    textLabel6->setGeometry( QRect( 10, 170, 43, 20 ) );

    lineEdit6 = new QLineEdit( this, "lineEdit6" );
    lineEdit6->setGeometry( QRect( 60, 10, 142, 24 ) );

    lineEdit7 = new QLineEdit( this, "lineEdit7" );
    lineEdit7->setGeometry( QRect( 60, 40, 142, 24 ) );

    lineEdit8 = new QLineEdit( this, "lineEdit8" );
    lineEdit8->setGeometry( QRect( 60, 70, 142, 24 ) );

    lineEdit9 = new QLineEdit( this, "lineEdit9" );
    lineEdit9->setGeometry( QRect( 60, 100, 142, 24 ) );

    lineEdit10 = new QLineEdit( this, "lineEdit10" );
    lineEdit10->setGeometry( QRect( 60, 130, 142, 24 ) );

    lineEdit11 = new QLineEdit( this, "lineEdit11" );
    lineEdit11->setGeometry( QRect( 60, 160, 142, 24 ) );

    buttonGroup3 = new QButtonGroup( this, "buttonGroup3" );
    buttonGroup3->setGeometry( QRect( 220, 10, 150, 130 ) );

    radioButton1 = new QRadioButton( buttonGroup3, "radioButton1" );
    radioButton1->setGeometry( QRect( 10, 30, 106, 22 ) );
    radioButton1->setChecked(true) ;

    radioButton3 = new QRadioButton( buttonGroup3, "radioButton3" );
    radioButton3->setGeometry( QRect( 10, 90, 70, 22 ) );

    radioButton2 = new QRadioButton( buttonGroup3, "radioButton2" );
    radioButton2->setGeometry( QRect( 10, 60, 70, 22 ) );

    comboBox3 = new QComboBox( FALSE, this, "comboBox3" );
    comboBox3->setGeometry( QRect( 220, 160, 150, 30 ) );

    lineEdit12 = new QLineEdit( this, "lineEdit12" );
    lineEdit12->setGeometry( QRect( 60, 190, 142, 24 ) );

    textLabel7 = new QLabel( this, "textLabel7" );
    textLabel7->setGeometry( QRect( 10, 200, 40, 20 ) );

    buttonOk = new QPushButton( this, "buttonOk" );
    buttonOk->setGeometry( QRect( 80, 230, 99, 30 ) );

    buttonCancel = new QPushButton( this, "buttonCancel" );
    buttonCancel->setGeometry( QRect( 250, 230, 99, 30 ) );

    //QWidget* privateLayoutWidget = new QWidget( this, "Layout5" );
    //privateLayoutWidget->setGeometry( QRect( 250, 230, 99, 30 ) );
    //Layout5 = new QVBoxLayout( privateLayoutWidget, 0, 6, "Layout5");

    setCaption(  "dialog3D"  );
    textLabel1->setText(  "x min"  );
    textLabel2->setText(  "x max" );
    textLabel3->setText(  "y min"  );
    textLabel4->setText(  "y max"  );
    textLabel5->setText(  "z min"  );
    textLabel6->setText(  "z max" );
    buttonGroup3->setTitle(  "z"  );
    radioButton1->setText(  "linear"  );
    radioButton3->setText(  "log log"  );
    radioButton2->setText(  "log"  );
    textLabel7->setText(  "name"  );

    //buttonOk = new QPushButton( privateLayoutWidget, "buttonOk" );
    buttonOk->setAutoDefault( TRUE );
    buttonOk->setDefault( TRUE );
    //Layout5->addWidget( buttonOk );

    //buttonCancel = new QPushButton( privateLayoutWidget, "buttonCancel" );
    buttonCancel->setAutoDefault( TRUE );
    //Layout5->addWidget( buttonCancel );

    //buttonHelp = new QPushButton( privateLayoutWidget, "buttonHelp" );
    //buttonHelp->setAutoDefault( TRUE );
    //Layout5->addWidget( buttonHelp );
    //QSpacerItem* spacer = new QSpacerItem( 20, 20, QSizePolicy::Minimum, QSizePolicy::Expanding );
    //Layout5->addItem( spacer );
    //languageChange();
    resize( QSize(387, 284).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );


    buttonOk->setText(  "&OK"  );
    buttonOk->setAccel( QKeySequence( QString::null ) );
    buttonCancel->setText(  "&Cancel" );
    buttonCancel->setAccel( QKeySequence( QString::null ) );

    lineEdit6->setText( "-4.0") ;
    lineEdit7->setText( "4.0") ;
    lineEdit8->setText( "-4.0") ;
    lineEdit9->setText( "4.0") ;
    lineEdit10->setText( "0.0") ;
    lineEdit11->setText( "0.3") ;
    lineEdit12->setText( "essai") ;
    comboBox3->clear();
    comboBox3->insertItem(  "VIDEOSCAPE (*.obj)",FORMAT_ID_VIDEOSCAPE );
    comboBox3->insertItem(  "SGML (*.3db)",FORMAT_ID_SGML  );
    comboBox3->insertItem(  "POV_RAY (*.pov)",FORMAT_ID_POV_RAY  );

    //buttonHelp->setText(  "&Help" ) );

    // signals and slots connections
    connect( buttonOk, SIGNAL( clicked() ), this, SLOT( accept() ) );
    connect( buttonCancel, SIGNAL( clicked() ), this, SLOT( reject() ) );
}

/*
 *  Destroys the object and frees any allocated resources
 */
dialog3D::~dialog3D()
{
    // no need to delete child widgets, Qt does it all for us
}

QString dialog3D :: get3D(double* xm,double* xM,double* ym,double* yM,double* zm ,double* zM,
			  int* format,int* typeAltitude)
{
 bool ok ;
 int ty ;

 *xm = (lineEdit6->text()).toDouble(&ok) ;
 if (not(ok)) *xm = 0.0 ;
 *xM = (lineEdit7->text()).toDouble(&ok) ;
 if (not(ok)) *xM = 1.0 ;
 *ym = (lineEdit8->text()).toDouble(&ok) ;
 if (not(ok)) *ym = 0.0 ;
 *yM = (lineEdit9->text()).toDouble(&ok) ;
 if (not(ok)) *yM = 1.0 ;
 *zm = (lineEdit10->text()).toDouble(&ok) ;
 if (not(ok)) *zm = 0.0 ;
 *zM = (lineEdit11->text()).toDouble(&ok) ;
 if (not(ok)) *zM = 0.2 ;
 *format = comboBox3->currentItem() ;
 if (radioButton1->isChecked()) ty = 0 ;
	else if (radioButton2->isChecked()) ty = 1 ; else ty = 2 ;
 *typeAltitude = ty ;
 return lineEdit12->text() ;
}







