#include <iostream>
#include <fstream>
using namespace std ;

#include <qpainter.h>
//#include <qsize.h>

#include "constants.h"
#include "dialogPalette.h"

#define SIZEW 128
#define SIZEH 32

//name = xyzwvu  where x,y,z,u,v,w = char 0,1,2,...,9,A,B,...,F
void string2RGBbis( char* name, long* r, long* g, long*b )
{
 long l,m;

 // Red
 l = name[0]-'0' ;
 if ((l<0) || (l>9))
	{
	 l = name[0] - 'A' ;
	 if ((l>=0) && (l<6)) l += 10 ; else l = 0 ;
	}
 l *= 16 ;
 m = name[1]-'0' ;
 if ((m<0) || (m>9))
	{
	 m = name[1] - 'A' ;
	 if ((m>=0) && (m<6)) m += 10 ; else m = 0 ;
	}
 *r = l+m ;

  // Green
 l = name[2]-'0' ;
 if ((l<0) || (l>9))
	{
	 l = name[2] - 'A' ;
	 if ((l>=0) && (l<6)) l += 10 ; else l = 0 ;
	}
 l *= 16 ;
 m = name[3]-'0' ;
 if ((m<0) || (m>9))
	{
	 m = name[3] - 'A' ;
	 if ((m>=0) && (m<6)) m += 10 ; else m = 0 ;
	}
 *g = l+m ;

 // Blue
 l = name[4]-'0' ;
 if ((l<0) || (l>9))
	{
	 l = name[4] - 'A' ;
	 if ((l>=0) && (l<6)) l += 10 ; else l = 0 ;
	}
 l *= 16 ;
 m = name[5]-'0' ;
 if ((m<0) || (m>9))
	{
	 m = name[5] - 'A' ;
	 if ((m>=0) && (m<6)) m += 10 ; else m = 0 ;
	}
 *b = l+m ;
}



dialogPalette :: dialogPalette(  const QString & dirName, const QString & filter  ,
				 QWidget* parent, const char* name, bool modal )
    : QFileDialog( dirName, filter, parent, name, modal )
{
 //QPainter windowpainter ;
 //QPainter bufferpainter ;
 //long j ;



 setName( "dialogPalette" );

 _imagePalette = new QWidget(this) ;
 _imagePalette->resize(SIZEW,SIZEH) ;
 _bufferImagePalette = new QPixmap(SIZEW,SIZEH) ;
 _bufferImagePalette->fill(QColor(192,192,192)) ;
 //bitBlt( _imagePalette , 0 , 0 , _bufferImagePalette  ) ;
 /*
 bufferpainter.begin(_bufferImagePalette) ;
 windowpainter.begin(_imagePalette) ;
 bufferpainter.setPen( QColor(100,0,0) ) ;
 windowpainter.setPen( QColor(100,0,0) ) ;
 for(j=0;j<SIZEW;j++) bufferpainter.drawLine(j,0,j,SIZEH-1) ;
 for(j=0;j<SIZEW;j++) windowpainter.drawLine(j,0,j,SIZEH-1) ;
 bufferpainter.end() ;
 windowpainter.end() ;
*/
 addWidgets(0,_imagePalette,0) ;

 //QObject::connect(this,SIGNAL(fileSelected( const QString &)),this,SLOT(printPalette( const QString &))) ;
 QObject::connect(this,SIGNAL(fileHighlighted( const QString &)),this,SLOT(printPalette( const QString &))) ;
}

/*
 *  Destroys the object and frees any allocated resources
 */
dialogPalette::~dialogPalette()
{
 delete _bufferImagePalette ;
    // no need to delete child widgets, Qt does it all for us
}

void dialogPalette :: printPalette( const QString & pal)
{
 QPainter windowpainter ;
 QPainter bufferpainter ;
 long i,r,g,b,nbC,j ;
 char ch[9] ;
 unsigned long* paletteRGB ;
 unsigned long co ;

 //cout << pal << endl ;
 ifstream entreeText( pal.latin1()  , ios::in ) ;

 if (entreeText)
 	{
	 entreeText.getline(ch,8) ;
	 if (not(entreeText.eof()))
		{
		 nbC = atol(ch) ;
		 if ((nbC>0) && (nbC<10000))
			{
			 paletteRGB = new unsigned long[nbC] ;
			 for(i=0;i<nbC;i++)
				{
				 entreeText.getline(ch,8) ;
				 if (entreeText.eof()) break ;
				 string2RGBbis( ch,&r,&g,&b ) ;
				 g <<= 8 ;
				 b <<= 16 ;
				 r += (g+b) ;
				 paletteRGB[i] = r ;
				}
			 bufferpainter.begin(_bufferImagePalette) ;
			 windowpainter.begin(_imagePalette) ;
			 for(i=0;i<SIZEW;i++)
				{
				 j = (i * (nbC-1)) / (SIZEW-1) ;
				 co = paletteRGB[j] ;
				 b = co >> 16 ;
				 g = (co >> 8) & MASK_BYTE ;
				 r = co & MASK_BYTE ;
				 bufferpainter.setPen( QColor(r,g,b) ) ;
				 bufferpainter.drawLine(i,0,i,SIZEH-1) ;
				 windowpainter.setPen( QColor(r,g,b) ) ;
				 windowpainter.drawLine(i,0,i,SIZEH-1) ;
				}
			 bufferpainter.end() ;
			 windowpainter.end() ;
			 delete paletteRGB ;
			}
		}
	}

}


void dialogPalette :: paintEvent( QPaintEvent* event )
{
 bitBlt( _imagePalette , 0 , 0 , _bufferImagePalette  ) ;
}





