#include "effectColorLog.h"
#include "conversionSpaceColor.h"
#include "sparam.h"
#include "planche.h"

effectColorLog :: effectColorLog()
{
 t = 0.0 ;
 inversed = 0 ;
}

effectColorLog :: ~effectColorLog()
{
}

void effectColorLog :: setParameters(sparam* p)
{
 bool ok ;

 t = (*p)[0].toDouble(&ok) ;
 if (not(ok)) t = 0.0 ;
 inversed = (*p)[1].toInt(&ok) ;
 if (not(ok)) inversed = 0 ;

 //cout << "@ k = " << k  << endl ;
 //cout << "@ N = " << N  << endl ;
 //cout << "@ inversed = " << inversed  << endl ;
}

void effectColorLog :: streamParameters( QTextStream& st )
{
}

void effectColorLog :: calculate( planche* pl )
{
 cout << " void effectColorLog :: calculate( planche* pl ) " << endl ;
 double h,s,v,aux,dlog,aux2 ;
 int i,j,minl,maxl,a,b,size ;
 int* m ;
 unsigned int* mc ;


 size = pl->getSize() ;
 m = pl->getMatrixLong() ;
 mc = pl->getMatrixColor() ;
 pl->getMinMax(&minl,&maxl) ;

 dlog = log(maxl-minl + 1.0 ) ;
 if (dlog > 0.0) dlog = 1/dlog ; else dlog = 1.0 ;


 if (inversed==0)
	{
	 for(i = 0 ; i < size ; i++)
		for( j=0 ; j < size ; j++ )
			{
			 a = m[i*size+j] ;
			 aux = log(a -minl + 1.0 ) * dlog ; // aux in [0;1]
			 b = mc[i*size+j] ;
			 rgb2hsv(&h,&s,&v,b ) ;
			 // v = aux + v * (1.0 - aux) ;
			 //aux2 = aux + v * (1.0 - aux) ;
			 v = (1.0-t)*aux + t*v ;
			 //if (v > 1.0) v = 1.0 ;
			 //if (v < 0.0) v = 0.0 ;
			 mc[i*size+j] = hsv2rgb(h,s,v) ;
			}
	}
 if (inversed==1)
	{
	 for(i = 0 ; i < size ; i++)
		for( j=0 ; j < size ; j++ )
			{
			 a = m[i*size+j] ;
			 aux = log(a -minl + 1.0 ) * dlog ; // aux in [0;1]
			 b = mc[i*size+j] ;
			 rgb2hsv(&h,&s,&v,b ) ;
			 //v = aux * v + 1.0 - aux ;
			 aux2 = aux * v + 1.0 - aux ;
			 //aux = sqrt(aux) ;
			 v = (1.0-t)*aux + t*aux2 ;
			 //if (v > 1.0) v = 1.0 ;
			 //if (v < 0.0) v = 0.0 ;
			 mc[i*size+j] = hsv2rgb(h,s,v) ;
			}
	}

}




