#include "effectFunctionApophysis_n3.h"
#include "sparam.h"
#include "planche.h"

effectFunctionApophysis_n3 :: effectFunctionApophysis_n3()
{
 k = 1.0 ;
 ik = 1.0 ;
}

effectFunctionApophysis_n3 :: ~effectFunctionApophysis_n3()
{
}

void effectFunctionApophysis_n3 :: setParameters(sparam* p)
{
 bool ok ;

 k = (*p)[0].toDouble(&ok) ;
 if (not(ok)) { k = 1.0 ; ik = 1.0 ; }
 if (k!= 0.0) ik = 1.0/k ; else ik = 1.0 ;
}

void effectFunctionApophysis_n3 :: streamParameters( QTextStream& st )
{
}

void effectFunctionApophysis_n3 :: calculate(double* x0p,double* y0p,double* ifs,int capp,double x0,double y0)
{
 double tx,ty,t,th ;
 //cout << " void effectFunctionApophysis_n3 :: calculate( planche* pl ) " << endl ;

 tx = k * x0 ;
 ty = k * y0 ;
 t = pow(tx*tx+ty*ty+1e-6,-0.4) ;
 if (tx != 0.0) th = atan(ty/tx) ; else  th = HALF_PI ;
 t *=  ik ;
 *x0p = ifs[capp+8] + t * tx * cos(t+th) ;
 *y0p = ifs[capp+9] + t * sin(t+th) ;
}




