#include "effectFunctionApophysis_n8.h"
#include "sparam.h"
#include "planche.h"

effectFunctionApophysis_n8 :: effectFunctionApophysis_n8()
{
 k = 1.0 ;
 ik = 1.0 ;
}

effectFunctionApophysis_n8 :: ~effectFunctionApophysis_n8()
{
}

void effectFunctionApophysis_n8 :: setParameters(sparam* p)
{
 bool ok ;

 k = (*p)[0].toDouble(&ok) ;
 if (not(ok)) { k = 1.0 ; ik = 1.0 ; }
 if (k!= 0.0) ik = 1.0/k ; else ik = 1.0 ;
}

void effectFunctionApophysis_n8 :: streamParameters( QTextStream& st )
{
}

void effectFunctionApophysis_n8 :: calculate(double* x0p,double* y0p,double* ifs,int capp,double x0,double y0)
{
 double tx,ty,t,th ;
 //cout << " void effectFunctionApophysis_n8 :: calculate( planche* pl ) " << endl ;
 tx = k * x0 ;
 ty = k * y0 ;
 t = sqrt(tx*tx+ty*ty) ;
 if (tx != 0.0) th = atan(ty/tx) ; else  th = HALF_PI ;
 t *= PII ;
 th *= ik ;
 *x0p = ifs[capp+8] + th * sin(t) ;
 *y0p = ifs[capp+9] + th * cos(t) ;
}




