#include "effectFunctionApophysis_n9.h"
#include "sparam.h"
#include "planche.h"

effectFunctionApophysis_n9 :: effectFunctionApophysis_n9()
{
 k = 1.0 ;
 ik = 1.0 ;
}

effectFunctionApophysis_n9 :: ~effectFunctionApophysis_n9()
{
}

void effectFunctionApophysis_n9 :: setParameters(sparam* p)
{
 bool ok ;

 k = (*p)[0].toDouble(&ok) ;
 if (not(ok)) { k = 1.0 ; ik = 1.0 ; }
 if (k!= 0.0) ik = 1.0/k ; else ik = 1.0 ;
}

void effectFunctionApophysis_n9 :: streamParameters( QTextStream& st )
{
}

void effectFunctionApophysis_n9 :: calculate(double* x0p,double* y0p,double* ifs,int capp,double x0,double y0)
{
 double tx,ty,t,th ;
 //cout << " void effectFunctionApophysis_n9 :: calculate( planche* pl ) " << endl ;

 tx = k * x0 ;
 ty = k * y0 ;
 t = sqrt(tx*tx+ty*ty) ;
 if (tx != 0.0) th = atan(ty/tx) ; else  th = HALF_PI ;
 tx   = cos(th) + sin(t) ;
 ty   = sin(th) - cos(t) ;
 t = ik / t ;
 *x0p = ifs[capp+8] + t * cos(tx) ;
 *y0p = ifs[capp+9] + t * sin(ty) ;
}




