#ifndef FENETREIMAGE_H
#define FENETREIMAGE_H

using namespace std ;
#include <vector>
#include <iostream>
#include <cmath>


#include <qwidget.h>
#include <qpoint.h>
#include <qpixmap.h>
#include <qimage.h>

#include "constants.h"

class QString ;

/*
 * Une fentre qui permet  l'utilisateur de dessiner avec la souris. La fentre
 * sait se redimensionner.
 */
class fenetreImage : public QWidget
{
 Q_OBJECT   //  fenetreImage cre des slots !!!

 public :
  fenetreImage() ;
  fenetreImage( QPixmap & s ) ;
  ~fenetreImage() ;
  void imageChanged( QPixmap*) ;
  void setKeyPressed(int) ;
  void saveIFS(QString ) ;
  void loadIFS(QString ) ;

 protected :
  virtual void mousePressEvent( QMouseEvent* ) ;
  virtual void mouseReleaseEvent( QMouseEvent* ) ;
  virtual void mouseMoveEvent( QMouseEvent* ) ;
  virtual void paintEvent( QPaintEvent* ) ;
  virtual void resizeEvent( QResizeEvent* ) ;
  //virtual void keyPressEvent( QKeyEvent* ) ;
  //virtual void keyReleaseEvent( QKeyEvent* ) ;

 signals :
  void signalIFSchanged( paralleVector*,int,int ) ;

 private slots :
 void slotBof() ;

 private :
  void calculateF(QPoint* ) ;
  void draw( QPoint*,bool ) ;
  void drawFrame(QPainter*,QPainter*,QPoint* ) ;
  int coteSelected(QPoint*,QPoint*,int,int) ;
  void fill(QPoint* ) ;
  void homothetie(double) ;
  void newRectangle() ;
  void tabRectangle() ;
  void supprRectangle() ;
  void duplicateRectangle() ;
  void printParalleVector() ;
  void firstRectangle() ;


  QPixmap _buffer ;
  QImage _source ;   // perte de mmoire mais on est oblig pour rcuprer les couleurs...
  double fr[6] ;
  double invHeight ;
  double invWidth ;
  paralleVector _paralleVector ;
  QPoint rect[4] ;
  QPoint newRect[4] ;
  QPoint mvtPoint ;
  int iheight,iwidth,keyPressed,sommet,cote,indiceParalle ;
  bool RectIsChanged ;
} ;

#endif






