#ifndef FENETREPRINCIPALE_H
#define FENETREPRINCIPALE_H


#include <qmainwindow.h>

#include "constants.h"

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QAction;
class QActionGroup;
class QToolBar;
class QPopupMenu;
class QTabWidget;
class QWidget;
class QLineEdit;
class QPushButton;
class QTextEdit;
class QButtonGroup;
class QCheckBox;
class QRadioButton;
class QLabel;
class QFrame;
//class QSlider ;
class QColor ;
class QComboBox ;
class QPixmap ;


class repartition ;
//class QDoubleSlider ;
class conteneurImage ;
class conteneurPlanche ;
class dialogPalette ;
class wEffectColor ;
class wEffectColorGamma ;
class wEffectColorRelief ;
class wEffectColorLog ;
class wEffectColorContrast ;
class wEffectFunction ;
class wEffectFunctionSlip ;
class wEffectFunctionApophysisNew ;
class sparam ;


class fenetrePrincipale : public QMainWindow
{
	Q_OBJECT   //  fenetrePrincipale cre des slots !!!

 public :
  fenetrePrincipale() ;  // constructeur
  ~fenetrePrincipale() ;  // dstructeur

 signals :
  //void signalDrawMatrix(int,int,int,int,bool) ;

 protected :
  virtual void paintEvent( QPaintEvent* event ) ;
  virtual void resizeEvent( QResizeEvent* event) ;

 private slots :
  void slotEffectColorChanged(int) ;
  void slotEffectChanged(int) ;
  void slotDialog3D() ;
  void slotSaveImage() ;
  void slotChangeImage() ;
  void slotSaveIFS() ;
  void slotLoadIFS() ;
  void slotLoadPalette() ;
  void slotSetPalette(const QString &) ;
  void slotIterationAndGermsChanged() ;
  //void slotKappaChanged() ;
  void slotDrawRepartitionZoomed(int,int) ;
  void slotRepartitionMinMaxChanged(int*,int,int) ;
  void slotDrawMatrixF10() ;
  void slotParameterColorationChanged() ;
  void slotSizeChanged(int) ;
  void slotCoordinateChanged() ;
  void slotFrameChanged(double,double,double,double) ;
  void slotDelay(double) ;
  void changeIFS(paralleVector*,int,int) ;
  void slotCalculate() ;
  void slotParametersEffectColorChanged() ;
  void slotParametersEffectChanged() ;
  void slotButtonInitFrame() ;
  void slotPreferences() ;
  void slotNeRienFaire() ;
  void slotAbout() ;
  void slotAboutQt() ;

 private :
  void changePaletteForRepartition() ;


    QTabWidget* tabWidget ;
    QWidget* _selection ;
    repartition* _repartition ;
    QWidget* _frame ;
    QLabel* textLabel3;
    QLineEdit* lineEdit5;
    QLineEdit* lineEdit6;
    QLineEdit* lineEdit7;
    QLineEdit* lineEdit8;
    QLineEdit* lineEdit9;
    QLineEdit* lineEdit10;
    QLabel* textLabel4;
    QLabel* textLabel5;
    QLabel* textLabel6;
    QLabel* textLabel7;
    QLabel* textLabel8;
    QPushButton* buttonInitFrame ;
    // menu
    QMenuBar* _menubar ;
    QPopupMenu* _fileMenu ;
    QPopupMenu* _transformationMenu ;
    QPopupMenu* _actionMenu ;
    QPopupMenu* _sizemenu ;
    QPopupMenu* _effectMenu ;
    QPopupMenu* _effectColorMenu ;
    QPopupMenu* _aboutMenu;
    QStatusBar* _statusbar ;
    
    dialogPalette* _dialogPalette ;
    wEffectColor* _wEffectColorPtr ;
    wEffectColor* _wEffectColor ;
    wEffectColorGamma* _wEffectColorGamma ;
    wEffectColorRelief* _wEffectColorRelief ;
    wEffectColorLog* _wEffectColorLog ;
    wEffectColorContrast* _wEffectColorContrast ;
    wEffectFunction* _wEffectFunctionPtr ;
    wEffectFunction* _wEffectFunction ;
    wEffectFunctionSlip* _wEffectFunctionSlip ;
    wEffectFunctionApophysisNew* _wEffectFunctionApophysisNew ;
    sparam* _paramEffectColor ;
    sparam* _paramEffectFunction ;

   QLabel* _labelInfo ;
   conteneurImage* _conteneurImage ;
   conteneurPlanche* _conteneurPlanche ;
   int repartitionZoom[SIZE_IMAGE_REPARTITION_X] ;
   parameterColoration _parameterColoration ;
   bool drawMatrixWithRepartitionColoration ;
   QString pale ;
   QString nomImage ;
} ;

#endif



