/*
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  aint with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "io.h"

double str2lf(char* string, unsigned int len,int* err )
{
 unsigned int k=0,nb_digit=0 ;
 unsigned char ctmp ;

 *err = 1 ;
 if (len == 0 ) return 0.0 ;
 ctmp=string[k] ;
 if ((ctmp!='+') && (ctmp!='-') && (ctmp!='.') && (isdigit(ctmp)==0)) return 0.0 ;
 if (isdigit(ctmp)!=0) nb_digit++ ;
 for(k=1;k<len;k++)
	{
	 ctmp = string[k] ;
	 if (isdigit(ctmp)!=0) nb_digit++ ; else break ;
	}

 if (k==len)
	{
	 *err = 0 ;
	 return(atof(string)) ;
	}
 if (ctmp=='.')
	{
	 k++ ;
	 if (k==len)
		{
		 *err = 0 ;
		 return(atof(string)) ;
		}
	 for(;k<len;k++)
		{
		 ctmp = string[k] ;
		 if (isdigit(ctmp)!=0) nb_digit++ ; else break ;
		}
	 if (k==len)
		{
		 *err = 0 ;
		 return(atof(string)) ;
		}
	}

 if (ctmp =='e')
	{
	 if (nb_digit==0) return 0.0 ;
	 k++ ;
	 if (k==len)  return 0.0 ;
	 ctmp = string[k] ;
	 if ((ctmp != '+') && (ctmp != '-') && (isdigit(ctmp)==0)) return 0.0 ;
	 if ((ctmp == '+') || (ctmp = '-')) k++ ;
	 for(;k<len;k++)
		{
		 ctmp = string[k] ;
		 if (isdigit(ctmp)!=0) nb_digit++ ; else break ;
		}
	 if (k==len)
		{
		 *err = 0 ;
		 return(atof(string)) ;
		}
		else return 0.0 ;
	}
	else
	{
	 return 0.0 ;
	}
}

int str2ld(char* string, unsigned int len,int* err )
{
 unsigned int k=0,nb_digit=0 ;
 unsigned char ctmp ;

 *err = 1 ;
 if (len == 0 ) return 0 ;
 ctmp=string[k] ;
 if ((ctmp!='+') && (ctmp!='-') && (isdigit(ctmp)==0)) return 0 ;
 if (isdigit(ctmp)!=0) nb_digit++ ;
 for(k=1;k<len;k++)
	{
	 ctmp = string[k] ;
	 if (isdigit(ctmp)!=0) nb_digit++ ; else break ;
	}

 if (k==len)
	{
	 *err = 0 ;
	 return(atol(string)) ;
	}
	else
	{
	 return 0 ;
	}
}

