#include <iostream>
#include <fstream>
using namespace std ;

#include <qfiledialog.h>
#include <qpainter.h>
#include <qmessagebox.h>
#include <qapplication.h>

#include "constants.h"
#include "planche.h"
//#include "calculate.h"
#include "conversionSpaceColor.h"
#include "effectColor.h"
#include "effectColorGamma.h"
#include "effectColorRelief.h"
#include "effectColorLog.h"
#include "effectColorContrast.h"
#include "sparam.h"
#include "effectFunction.h"
#include "effectFunctionSlip.h"
#include "effectFunctionComplex.h"
#include "effectFunctionApophysis_1.h"
#include "effectFunctionApophysis_2.h"
#include "effectFunctionApophysis_3.h"
#include "effectFunctionApophysis_4.h"
#include "effectFunctionApophysis_5.h"
#include "effectFunctionApophysis_6.h"
#include "effectFunctionApophysis_7.h"
#include "effectFunctionApophysis_8.h"
#include "effectFunctionApophysis_9.h"
#include "effectFunctionApophysis_10.h"
#include "effectFunctionApophysis_11.h"
#include "effectFunctionApophysis_12.h"
#include "effectFunctionApophysis_13.h"
#include "effectFunctionApophysis_n1.h"
#include "effectFunctionApophysis_n2.h"
#include "effectFunctionApophysis_n3.h"
#include "effectFunctionApophysis_n4.h"
#include "effectFunctionApophysis_n5.h"
#include "effectFunctionApophysis_n6.h"
#include "effectFunctionApophysis_n7.h"
#include "effectFunctionApophysis_n8.h"
#include "effectFunctionApophysis_n9.h"
#include "effectFunctionApophysis_n10.h"
#include "effectFunctionApophysis_n11.h"
#include "effectFunctionApophysis_n12.h"
#include "effectFunctionApophysis_n13.h"

//name = xyzwvu  where x,y,z,u,v,w = char 0,1,2,...,9,A,B,...,F
void string2RGB( char* name, int* r, int* g, int*b )
{
 int l,m;

 // Red
 l = name[0]-'0' ;
 if ((l<0) || (l>9))
	{
	 l = name[0] - 'A' ;
	 if ((l>=0) && (l<6)) l += 10 ; else l = 0 ;
	}
 l *= 16 ;
 m = name[1]-'0' ;
 if ((m<0) || (m>9))
	{
	 m = name[1] - 'A' ;
	 if ((m>=0) && (m<6)) m += 10 ; else m = 0 ;
	}
 *r = l+m ;

  // Green
 l = name[2]-'0' ;
 if ((l<0) || (l>9))
	{
	 l = name[2] - 'A' ;
	 if ((l>=0) && (l<6)) l += 10 ; else l = 0 ;
	}
 l *= 16 ;
 m = name[3]-'0' ;
 if ((m<0) || (m>9))
	{
	 m = name[3] - 'A' ;
	 if ((m>=0) && (m<6)) m += 10 ; else m = 0 ;
	}
 *g = l+m ;

 // Blue
 l = name[4]-'0' ;
 if ((l<0) || (l>9))
	{
	 l = name[4] - 'A' ;
	 if ((l>=0) && (l<6)) l += 10 ; else l = 0 ;
	}
 l *= 16 ;
 m = name[5]-'0' ;
 if ((m<0) || (m>9))
	{
	 m = name[5] - 'A' ;
	 if ((m>=0) && (m<6)) m += 10 ; else m = 0 ;
	}
 *b = l+m ;
}

/*
double arg(double x,double y)
{
 if (x == 0.0)
	{
	 if (y >0.0) return HALF_PI ; else return - HALF_PI ;
	}
 if (x > 0.0) return atan(y/x) ; else return atan(y/x) + PII ;
}*/

planche :: planche( QWidget* parent=0,const char* name=0, WFlags f=0 ) : QWidget(parent,name,f)
{
 int k ;
 unsigned int temp, temp2 ;

 setBackgroundMode( NoBackground ) ;
 sizeX = SIZE_PLANCHE ;
 resize( QSize(SIZE_PLANCHE,SIZE_PLANCHE) );
 _buffer.resize( QSize(SIZE_PLANCHE,SIZE_PLANCHE) ) ;
 bitBlt( this , 0 , 0 , &_buffer ) ;
 nbIFS = 0 ;
 iterations = 1000 ;
 ifs = NULL ;
 effetNonLinaire = EFFECT_ID_NONE ;
 effetCouleur = EFFECT_COLOR_ID_NONE ;
 algorithm_coloration = ALGORITHM_COLORATION_ID_REPARTITION ;

 palette.colors = new unsigned int[1786] ;
 palette.nbColors = 1786 ;
 for( k=0 ; k < 256 ; k++ )
 	{
	 temp = 255 ;
	 temp <<= 16 ;
	 temp2 = 255-k ;
	 temp2 <<= 8 ;
	 temp += temp2 ;
	 temp += 255 ;
	 palette.colors[k] = temp ;
	}

  for( k=1 ; k < 256 ; k++ )
 	{
	 temp = 255-k ;
	 temp <<= 16 ;
	 temp += 255 ;
	 palette.colors[k+255] = temp ;
	 temp = k ;
	 temp <<= 8 ;
	 temp += 255 ;
	 palette.colors[k+510] = temp ;
	 temp = 255 ;
	 temp <<= 8 ;
	 temp += (255-k) ;
	 palette.colors[k+765] = temp ;
	 temp = k ;
	 temp <<= 16 ;
	 temp2 = 255 ;
	 temp2 <<= 8 ;
	 temp += temp2 ;
	 palette.colors[k+1020] = temp ;
	 temp = 255 ;
	 temp <<= 16 ;
	 temp2 = 255-k ;
	 temp2 <<= 8 ;
	 temp += temp2 ;
	 palette.colors[k+1275] = temp ;
	 temp = 255-k ;
	 temp <<= 16 ;
	 palette.colors[k+1530] = temp ;
	}

 matrixInteger = new int[sizeX*sizeX] ;
 matrixColor = new unsigned int[sizeX*sizeX] ;
 matrixSigma = new unsigned int[sizeX*sizeX] ;
 xMin = -2.5 ;
 xMax = 2.5 ;
 yMin = -2.5 ;
 yMax = 2.5 ;
 xMinNew = xMin ;
 yMinNew = yMin ;
 xMaxNew = xMax ;
 yMaxNew = yMax ;
 dx = (xMax-xMin)/sizeX ;
 dy = (yMax-yMin)/sizeX ;

 _effectColor = new effectColor() ;
 _effectColorGamma = new effectColorGamma() ;
 _effectColorRelief = new effectColorRelief() ;
 _effectColorLog = new effectColorLog() ;
 _effectColorContrast = new effectColorContrast() ;
 _effectColorPtr = _effectColor ;

 _effectFunction = new effectFunction() ;
 _effectFunctionSlip = new effectFunctionSlip() ;
 _effectFunctionComplex = new effectFunctionComplex() ;
 _effectFunctionApophysis_1 = new effectFunctionApophysis_1() ;
 _effectFunctionApophysis_2 = new effectFunctionApophysis_2() ;
 _effectFunctionApophysis_3 = new effectFunctionApophysis_3() ;
 _effectFunctionApophysis_4 = new effectFunctionApophysis_4() ;
 _effectFunctionApophysis_5 = new effectFunctionApophysis_5() ;
 _effectFunctionApophysis_6 = new effectFunctionApophysis_6() ;
 _effectFunctionApophysis_7 = new effectFunctionApophysis_7() ;
 _effectFunctionApophysis_8 = new effectFunctionApophysis_8() ;
 _effectFunctionApophysis_9 = new effectFunctionApophysis_9() ;
 _effectFunctionApophysis_10 = new effectFunctionApophysis_10() ;
 _effectFunctionApophysis_11 = new effectFunctionApophysis_11() ;
 _effectFunctionApophysis_12 = new effectFunctionApophysis_12() ;
 _effectFunctionApophysis_13 = new effectFunctionApophysis_13() ;
 _effectFunctionApophysis_n1 = new effectFunctionApophysis_n1() ;
 _effectFunctionApophysis_n2 = new effectFunctionApophysis_n2() ;
 _effectFunctionApophysis_n3 = new effectFunctionApophysis_n3() ;
 _effectFunctionApophysis_n4 = new effectFunctionApophysis_n4() ;
 _effectFunctionApophysis_n5 = new effectFunctionApophysis_n5() ;
 _effectFunctionApophysis_n6 = new effectFunctionApophysis_n6() ;
 _effectFunctionApophysis_n7 = new effectFunctionApophysis_n7() ;
 _effectFunctionApophysis_n8 = new effectFunctionApophysis_n8() ;
 _effectFunctionApophysis_n9 = new effectFunctionApophysis_n9() ;
 _effectFunctionApophysis_n10 = new effectFunctionApophysis_n10() ;
 _effectFunctionApophysis_n11 = new effectFunctionApophysis_n11() ;
 _effectFunctionApophysis_n12 = new effectFunctionApophysis_n12() ;
 _effectFunctionApophysis_n13 = new effectFunctionApophysis_n13() ;
 _effectFunctionPtr = _effectFunction ;

 // initialisation des variables pour la gestion du cadre
 frameCreated  = FALSE ;
 overallMvt    = FALSE ;
 typeButtonPressed = NoButton ;
 frameChanged  = -1 ;
}

planche :: ~planche()
{
 if (palette.colors != NULL) delete palette.colors ;
 if (matrixInteger != NULL) delete matrixInteger ;
 if (matrixColor != NULL) delete matrixColor ;
 if (matrixSigma != NULL) delete matrixSigma ;
 if (ifs != NULL) delete ifs ;
 delete _effectColor ;
 delete _effectColorGamma ;
 delete _effectColorRelief ;
 delete _effectColorLog ;
 delete _effectColorContrast ;
 delete _effectFunctionSlip ;
 delete _effectFunctionComplex ;
 delete  _effectFunctionApophysis_1  ;
 delete _effectFunctionApophysis_2  ;
 delete _effectFunctionApophysis_3  ;
 delete _effectFunctionApophysis_4  ;
 delete _effectFunctionApophysis_5  ;
 delete _effectFunctionApophysis_6  ;
 delete _effectFunctionApophysis_7  ;
 delete _effectFunctionApophysis_8  ;
 delete _effectFunctionApophysis_9  ;
 delete _effectFunctionApophysis_10  ;
 delete _effectFunctionApophysis_11  ;
 delete _effectFunctionApophysis_12  ;
 delete _effectFunctionApophysis_13  ;
 delete _effectFunctionApophysis_n1  ;
 delete _effectFunctionApophysis_n2  ;
 delete _effectFunctionApophysis_n3  ;
 delete _effectFunctionApophysis_n4  ;
 delete _effectFunctionApophysis_n5  ;
 delete _effectFunctionApophysis_n6  ;
 delete _effectFunctionApophysis_n7  ;
 delete _effectFunctionApophysis_n8  ;
 delete _effectFunctionApophysis_n9  ;
 delete _effectFunctionApophysis_n10  ;
 delete _effectFunctionApophysis_n11  ;
 delete _effectFunctionApophysis_n12  ;
 delete _effectFunctionApophysis_n13  ;
}

int planche :: getSize() { return sizeX ; }
int* planche :: getMatrixLong() { return matrixInteger ; }
unsigned int* planche :: getMatrixColor() { return matrixColor ;}
void planche :: getMinMax(int* m,int* M) { *m = mini ; *M = maxi ; } ;
void planche :: changeParameterEffectColor( sparam* sp) { _effectColorPtr->setParameters(sp) ; }
void planche :: changeParameterEffect( sparam* sp) { _effectFunctionPtr->setParameters(sp) ; }

void planche :: changeIFS(paralleVector* p,int h,int w)
{
 double invWidth,height,invHeight,weight,tmp,tmp2,tmp3 ;
 int nbifs,i,ii ;
 //vector<parallelogramme> :: iterator iv ;
 QPoint re[4] ;

 nbifs = p->size() ;

 //cout << endl ;
 //cout << " planche :: nbIFS = " << nbifs << endl ;
 if (nbifs != nbIFS)
	{
	 delete ifs ;
	 ifs = new double[nbifs*10] ;
	 nbIFS = nbifs ;
	}

 height = h ;
 weight = 0.0 ;
 if (h != 0) invHeight = 1.0 / h ; else invHeight = 1.0 ;
 if (w != 0) invWidth = 1.0 / w ; else invWidth = 1.0 ;

 for(i=0;i<nbifs;i++)
	{
	 ii = 10*i ;
	 (*p)[i].get(re) ;
	 ifs[ii] = (re[1].x()-re[0].x()) * invWidth ; // aa = a
	 ifs[ii+1] = (re[0].x()-re[3].x()) * invHeight ; // bb = -b
	 ifs[ii+2] = (re[0].y()-re[1].y()) * invWidth ; // cc = -c
	 ifs[ii+3] = (re[3].y()-re[0].y()) * invHeight ; // dd = d
	 ifs[ii+4] = ( re[0].x() - ifs[ii+1] * height) * invWidth  ; // ee
	 ifs[ii+5] = ( height - ifs[ii+3] * height - re[0].y()) * invWidth ; // ff
	 tmp = ifs[ii] * ifs[ii+3] - ifs[ii+1] * ifs[ii+2] ; // dterminant
	 ifs[ii+6] = fabs(tmp) ;
	 weight += ifs[ii+6] ;
	 tmp += 1.0-ifs[ii]-ifs[ii+3] ;
	 tmp2 = ifs[ii] - 1.0 ; // A pour le calcul du point fixe
	 tmp3 = ifs[ii+3] - 1.0 ; // D pour le calcul du point fixe
	 if (tmp != 0.0) tmp = 1.0/ tmp ; else tmp = 0.0 ;
	 ifs[ii+8] = ( ifs[ii+2] * ifs[ii+4] - tmp2 * ifs[ii+5] ) * tmp ;
	 ifs[ii+9] = ( ifs[ii+1] * ifs[ii+5] - tmp3 * ifs[ii+4] ) * tmp ;
	 // calcul du coefficient de contractance
	 // delta = (a^2-b^2+c^2-d^2)^2 + 4 (ab+cd)^2
	 // Xmax = 0.5 * (a^2 + b^2 + c^2 + d^2 + sqrt(delta) )
	 // vp max = sqrt( Xmax)
	 tmp = ifs[ii] * ifs[ii] - ifs[ii+1] * ifs[ii+1] + ifs[ii+2] * ifs[ii+2] - ifs[ii+3] * ifs[ii+3] ;
	 tmp2 = ifs[ii] * ifs[ii+1] + ifs[ii+2] * ifs[ii+3] ;
	 tmp2 = sqrt( tmp*tmp + 4.0*tmp2*tmp2 ) ;
	 tmp = ifs[ii] * ifs[ii] + ifs[ii+1] * ifs[ii+1] + ifs[ii+2] * ifs[ii+2] + ifs[ii+3] * ifs[ii+3] ;
	 tmp = 0.5 * ( tmp + tmp2 ) ;
	 ifs[ii+7] = sqrt( tmp ) ;
	}

 // normalisation des poids
 if (weight != 0.0 ) weight = 1.0 / weight ; else weight = 1.0 ;
 for(i=0;i<nbifs;i++) ifs[10*i+6] *= weight ;

/*
 cout << " a b c d e f w rho Xc Yc " << endl ;
 for(i=0;i<nbifs;i++)
	cout << ifs[10*i] << " " << ifs[10*i+1] << " " << ifs[10*i+2] << " " << ifs[10*i+3] <<
		" " << ifs[10*i+4] << " " << ifs[10*i+5] << " " << ifs[10*i+6] << " "
		<< ifs[10*i+7] << " " << ifs[10*i+8] << " " << ifs[10*i+9] << endl ;
*/
}

void planche :: calculateMiniMaxi()
{
 int i,j,minl,maxl,a ;

 minl = matrixInteger[0] ;
 maxl = matrixInteger[0] ;

  for(i = 0 ; i < sizeX ; i++)
	 for( j=0 ; j < sizeX ; j++ )
	 	{
		 a = matrixInteger[i*sizeX+j] ;
		 if (a>maxl) maxl = a ;
		 if (a<minl) minl = a ;
		}

 mini = minl ;
 maxi = maxl ;
}


// calcule la rpartition des valeurs de la matrice matrixInt
// entre les valeurs a et b et stocke le rsulat dans t[SIZE_IMAGE_REPARTITION_X].
void planche :: calculateRepartition(int*t,int a,int b)
{
 int ta[SIZE_IMAGE_REPARTITION_X+1] ;
 int k,i,aux,s ;

 for(i=0;i<=SIZE_IMAGE_REPARTITION_X;i++) ta[i] = a + (i * (b-a))/SIZE_IMAGE_REPARTITION_X ;

 for(i=0;i<SIZE_IMAGE_REPARTITION_X;i++) t[i] = 0 ;
 s = sizeX*sizeX ;
 for(k=0;k<s;k++)
	{
	 aux = matrixInteger[k] ;
	 for(i=0;i<SIZE_IMAGE_REPARTITION_X-1;i++)
		{
		 if ((aux>=ta[i]) && (aux<ta[i+1]))
			{
			 t[i]++ ;
			 break ;
			}
		}
	 if ((aux>=ta[SIZE_IMAGE_REPARTITION_X-1]) && (aux<=ta[SIZE_IMAGE_REPARTITION_X]))
			 t[SIZE_IMAGE_REPARTITION_X-1]++ ;
	}
}

void planche :: setFrame(double xmi,double xma, double ymi, double yma )
{
}

void planche :: calculate()
{
 double irand,dX,dY,coefx,coefy,tmp,x0,y0,x1,y1,suite,happ ;
 int i,j,k,kk,capp,sdiff ;
 //unsigned int tmp ;
 time_t rand_germe ;
 time_t t1,t2 ;

 if (nbIFS <=2) return ;
 cout << " effetNonLinaire = " << effetNonLinaire << endl ;

 for(i=0;i<sizeX;i++)
	for(j=0;j<sizeX;j++) matrixInteger[j+i*sizeX] = 0 ;

 for(i=0;i<sizeX;i++)
	for(j=0;j<sizeX;j++) matrixSigma[j+i*sizeX] = 0 ;

 rand_germe = time(NULL) ;
 rand_germe *= rand_germe+13 ;
 rand_germe *= rand_germe ;
 rand_germe *= rand_germe ;
 srand((unsigned int)rand_germe) ;
 sdiff = (_parameterColoration.sizeTable - 1)/ nbIFS ;


 if (dx != 0.0) coefx = 1.0/dx ; else coefx = 512.0 ;
 if (dy != 0.0) coefy = 1.0/dy ; else coefy = 512.0 ;
 irand = 1.0 / RAND_MAX ;
 dX = dx * sizeX ;
 dY = dy * sizeX ;

 t1 = time(NULL) ;
 if (effetNonLinaire == EFFECT_ID_NONE)
	{
	 // linaire
	 cout << " // linaire" << endl ;

	 for(i=0;i<sizeX;i++)
		for(j=0;j<sizeX;j++) matrixInteger[j+i*sizeX] = 0 ;

	 for(kk=0;kk<nbGerms;kk++)
		{
		 x0 = rand() * irand ;
		 y0 = rand() * irand ;
		 x0 = xMin+(-1.0+x0*3.0)*dX;
		 y0 = yMax-(-1.0+y0*3.0)*dY;
		 for(k=0;k<100;k++)
			{
			 happ = rand() * irand ;
			 capp = 0 ;
			 suite = ifs[6] ;
			 while( happ > suite)
				{
				 capp += 10 ;
				 suite += ifs[capp+6] ;
				}

			 tmp = ifs[capp] * x0 + ifs[capp+1] * y0 + ifs[capp+4] ;
			 y0  = ifs[capp+2] * x0 + ifs[capp+3] * y0 + ifs[capp+5] ;
			 x0  = tmp ;
			}
		 for(k=0;k<iterations;k++)
			{
			 happ = rand() * irand ;
			 capp = 0 ;
			 suite = ifs[capp+6] ;
			 while( happ > suite)
				{
				 capp += 10 ;
				 suite += ifs[capp+6] ;
				}

			 tmp = ifs[capp] * x0 + ifs[capp+1] * y0 + ifs[capp+4] ;
			 y0  = ifs[capp+2] * x0 + ifs[capp+3] * y0 + ifs[capp+5] ;
			 x0  = tmp ;

			 x1 = (x0-xMin)*coefx ;
			 y1 = (yMax-y0)*coefy ;
			 if (fabs(x1) + fabs(y1) > 1e5) break;
			 i = int(y1) ;
			 j = int(x1) ;
			 if ((i>=0) && (i<sizeX) && (j>=0) && (j<sizeX))
				{
				 matrixInteger[i*sizeX+j]++ ;
				 capp = capp/10 + 1 ;
				 matrixSigma[i*sizeX+j] = (matrixSigma[i*sizeX+j] + capp * sdiff ) >> 1 ;
				}
			}
		}
	}
	else
	{
	 //effects non linaire
	 cout << "  //effects NON linaire  " << endl ;
	 if (dx != 0.0) coefx = 1.0/dx ; else coefx = 512.0 ;
	 if (dy != 0.0) coefy = 1.0/dy ; else coefy = 512.0 ;
	 irand = 1.0 / RAND_MAX ;
	 dX = dx * sizeX ;
	 dY = dy * sizeX ;

	 for(kk=0;kk<nbGerms;kk++)
		{
		 x0 = rand() * irand ;
		 y0 = rand() * irand ;
		 x0 = xMin+(-1.0+x0*3.0)*dX;
		 y0 = yMax-(-1.0+y0*3.0)*dY;
		 for(k=0;k<100;k++)
			{
			 happ = rand() * irand ;
			 capp = 0 ;
			 suite = ifs[6] ;
			 while( happ > suite)
				{
				 capp += 10 ;
				 suite += ifs[capp+6] ;
				}

			 x0 -= ifs[capp+8] ; // on recentre par rapport au pont fixe
			 y0 -= ifs[capp+9] ;
			 tmp = ifs[capp] * x0 + ifs[capp+1] * y0  ;
			 y0  = ifs[capp+2] * x0 + ifs[capp+3] * y0  ;
			 _effectFunctionPtr->calculate(&x0,&y0,ifs,capp,tmp,y0 ) ;
			}
		 for(k=0;k<iterations;k++)
			{
			 happ = rand() * irand ;
			 capp = 0 ;
			 suite = ifs[capp+6] ;
			 while( happ > suite)
				{
				 capp += 10 ;
				 suite += ifs[capp+6] ;
				}
			 x0 -= ifs[capp+8] ; // on recentre par rapport au pont fixe
			 y0 -= ifs[capp+9] ;
			 tmp = ifs[capp] * x0 + ifs[capp+1] * y0  ;
			 y0  = ifs[capp+2] * x0 + ifs[capp+3] * y0  ;
			 //x0  = tmp ;

			 _effectFunctionPtr->calculate(&x0,&y0,ifs,capp,tmp,y0 ) ;
			 //x0 = x1 ;
			 //y0 = y1 ;

			 x1 = (x0-xMin)*coefx ;
			 y1 = (yMax-y0)*coefy ;
			 if (fabs(x1) + fabs(y1) > 1e5) break;
			 i = int(y1) ;
			 j = int(x1) ;
			 if ((i>=0) && (i<sizeX) && (j>=0) && (j<sizeX))
				{
				 matrixInteger[i*sizeX+j]++ ;
				 capp = capp/10 + 1 ;
				 matrixSigma[i*sizeX+j] = (matrixSigma[i*sizeX+j] + capp * sdiff ) >> 1 ;
				}
			}
		}
	}

 t2 = time(NULL) ;
 emit signalDelay(difftime(t2,t1)) ;
}

void planche :: changeParameterColoration(parameterColoration* p)
{
 //int i,n ;

 //cout << endl ;
 //cout << "  p->minZoomed = " << p->minZoomed << endl ;
 //cout << "  p->maxZoomed = " << p->maxZoomed << endl ;
 //cout << "  p->low       = " << p->low << endl ;
 //cout << "  p->high      = " << p->high << endl ;
 //cout << "  p->sizeTable = " << p->sizeTable << endl ;
 //cout << "  p->maxValue  = " << p->maxValue  << endl ;
 //cout << "  p->table     = " << p->table << endl ;

 _parameterColoration.minZoomed = p->minZoomed ;
 _parameterColoration.maxZoomed = p->maxZoomed ;
 _parameterColoration.low = p->low ;
 _parameterColoration.high = p->high ;
 _parameterColoration.sizeTable = p->sizeTable ;
 _parameterColoration.maxValue = p->maxValue ;
 _parameterColoration.table = p->table ; // remarque importante : il n' y a pas de recopie !

 //n = _parameterColoration.sizeTable ;
 //for(i=0;i<n;i++) cout << " " << _parameterColoration.table[i] ;
 //cout << endl ;
}

unsigned int planche :: colorCentraleZone(int reste,int d,double coefColorValue)
{
 double y,frac ;
 int ic,co,dc,a,b ;

 d-- ;
 b = _parameterColoration.sizeTable - 1 ;
 a = reste*b ;
 ic = a/d ;
 co = a - ic * d ;
 frac = co ;
 frac /= d ;
 co = _parameterColoration.table[ic] ;
 if (ic < b ) dc = _parameterColoration.table[ic+1] - co ; else dc = 0 ;
 y  = (co + frac * dc) * coefColorValue ;
 ic = (int) y ;
 return palette.colors[ic] ;
}

unsigned int planche :: colorLowZone(int quot,int reste,int d,int x,double coefColorValue)
{
 double y,frac,h,s,v,k ;
 int ic,co,b,dc ;
 unsigned int a ;

 switch(_parameterColoration.low)
	{
	 case SATURED_ID :
			co = _parameterColoration.table[0] ;
			y  = (co) * coefColorValue ;
			ic = (int) y ;
			return palette.colors[ic] ;
	 		break ;
	 case MODULO_ID  :
			d-- ;
			a = reste*(_parameterColoration.sizeTable - 1) ;
			ic = a/d ;
			co = a - ic * d ;
			frac = co ;
			frac /= d ;
			co = _parameterColoration.table[ic] ;
			dc = _parameterColoration.table[ic+1] - co ;
			y  = (co + frac * dc) * coefColorValue ;
			ic = (int) y ;
			return palette.colors[ic] ;
			break ;
	 case CYCLE_ID   :
			d-- ;
			if ((quot &1) == 1 )reste = d - reste ;
			a = reste*(_parameterColoration.sizeTable - 1) ;
			ic = a/d ;
			co = a - ic * d ;
			frac = co ;
			frac /= d ;
			co = _parameterColoration.table[ic] ;
			dc = _parameterColoration.table[ic+1] - co ;
			y  = (co + frac * dc) * coefColorValue ;
			ic = (int) y ;
			return palette.colors[ic] ;
			break ;
	 case DARK_ID    :
			co = _parameterColoration.table[0] ;
			y  = (co) * coefColorValue ;
			ic = (int) y ;
			a = palette.colors[ic] ;
			rgb2hsv(&h,&s,&v,a ) ;
			b = (_parameterColoration.minZoomed-x)*50 ;
			dc = _parameterColoration.minZoomed-mini ;
			if (dc != 0) b /= dc ; else b = 0 ;
			if (v<INF_VALUE) v = INF_VALUE ;
			k = pow(v/INF_VALUE,0.02) ; // 0.02 = 1/50
			y = 1.0 ;
			//cout << "("<< v << "," << b << "," << k << "," ;
			for(dc=1;dc<b;dc++) y *= k ;
			v /= y ;
			//cout << v << ") " ;
			return hsv2rgb(h,s,v) ;
			break ;
	 case BRIGHT_ID  :
			co = _parameterColoration.table[0] ;
			y  = (co) * coefColorValue ;
			ic = (int) y ;
			a = palette.colors[ic] ;
			rgb2hsv(&h,&s,&v,a ) ;
			b = (_parameterColoration.minZoomed-x)*50 ;
			dc = _parameterColoration.minZoomed-mini ;
			if (dc != 0) b /= dc ; else b = 0 ;
			if (v<INF_VALUE) v = INF_VALUE ;
			k = pow(SUP_VALUE/v,0.02) ;  // 0.02 = 1/50
			//cout << "("<< v << "," << b << "," ;
			y = 1.0 ;
			for(dc=1;dc<b;dc++) y *= k ;
			v *= y ;
			//cout << v << ") " ;
			if (v>SUP_VALUE) v = SUP_VALUE ;
			return hsv2rgb(h,s,v) ;
			break ;
	}
}

unsigned int planche :: colorHighZone(int quot,int reste,int d,int x,double coefColorValue)
{
 double y,frac ;
 int ic,co,dc,a ;

 switch(_parameterColoration.high)
	{
	 case SATURED_ID :
			co = _parameterColoration.table[_parameterColoration.sizeTable - 1] ;
			y  = (co) * coefColorValue ;
			ic = (int) y ;
			return palette.colors[ic] ;
	 		break ;
	 case MODULO_ID  :
			d-- ;
			a = reste*(_parameterColoration.sizeTable - 1) ;
			ic = a/d ;
			co = a - ic * d ;
			frac = co ;
			frac /= d ;
			co = _parameterColoration.table[ic] ;
			dc = _parameterColoration.table[ic+1] - co ;
			y  = (co + frac * dc) * coefColorValue ;
			ic = (int) y ;
			a = palette.colors[ic] ;
			return palette.colors[ic] ;
			break ;
	 case CYCLE_ID   :
			d-- ;
			if ((quot &1) == 1 )reste = d - reste ;
			a = reste*(_parameterColoration.sizeTable - 1) ;
			ic = a/d ;
			co = a - ic * d ;
			frac = co ;
			frac /= d ;
			co = _parameterColoration.table[ic] ;
			dc = _parameterColoration.table[ic+1] - co ;
			y  = (co + frac * dc) * coefColorValue ;
			ic = (int) y ;
			return palette.colors[ic] ;
			break ;
	 case DARK_ID    :
			break ;
	 case BRIGHT_ID  :
			break ;
	}
}


void planche :: drawMatrix()
{
 QPainter windowpainter ;
 QPainter bufferpainter ;
 //QColor cl ;
 double coefColorValue;
 int a,i ,j,quot,rest,delta,b,r,g  ;
 unsigned int col ;

 if (nbIFS <=2)
	{
	 _buffer.fill(white) ;
	 bitBlt( this , 0 , 0 , &_buffer ) ;
	 cout << " not enough of IFS functions ! (minimum 3)" << endl ;
	 return ;
	}

 if (_parameterColoration.maxValue != 0) coefColorValue = 1.0 / _parameterColoration.maxValue ;
 	else coefColorValue = 0.0 ;
 coefColorValue *= (palette.nbColors - 1) ;

 switch(algorithm_coloration)
	{
	 case ALGORITHM_COLORATION_ID_SIGMA :

		 for( i = 0 ; i < sizeX ; i++ )
		 	for( j = 0 ; j < sizeX ; j++ )
				{
				 a = _parameterColoration.table[matrixSigma[i*sizeX+j]] ;
				 a = (int) a * coefColorValue ;
				 matrixColor[i*sizeX+j] = palette.colors[a] ;
				}

		break ;

	 case ALGORITHM_COLORATION_ID_REPARTITION :

		 delta = _parameterColoration.maxZoomed - _parameterColoration.minZoomed ; //-1 ;
		 if (delta == 1) delta = 2 ;
		 if (delta == 0)
			{
			 delta = 2 ;
			 cout << " beurk " << endl ;
			}

		 for( i = 0 ; i < sizeX ; i++ )
		 	for( j = 0 ; j < sizeX ; j++ )
				{
				 b = matrixInteger[i*sizeX+j] ;
				 a = b - _parameterColoration.minZoomed ;
				 quot = a / delta ;
				 rest = a - quot * delta ;
				 if (rest<0) { quot-- ; rest += delta ; }
				 if (quot==0) col = colorCentraleZone(rest,delta,coefColorValue) ;
					else
					{
					 if (quot<0) col = colorLowZone(quot,rest,delta,b,coefColorValue) ;
						else col = colorHighZone(quot,rest,delta,b,coefColorValue) ;
					}
				 matrixColor[i*sizeX+j] = col ;
				}
		 break ;
	}

 _effectColorPtr->calculate(this) ;

 windowpainter.begin(this) ;
 bufferpainter.begin( &_buffer ) ;

 for( i = 0 ; i < sizeX ; i++ )
 	for( j = 0 ; j < sizeX ; j++ )
		{
		 col = matrixColor[i*sizeX+j] ;
		 r = col & MASK_COLOR ;
		 g = (col >> 8) & MASK_COLOR ;
		 b = (col >> 16) & MASK_COLOR ;
		 bufferpainter.setPen( QColor(r,g,b) ) ;
		 bufferpainter.drawPoint(j,i) ;
		 windowpainter.setPen( QColor(r,g,b) ) ;
		 windowpainter.drawPoint(j,i) ;
		}
 //cout << endl ;
 //cout << endl ;
 bufferpainter.end() ;
 windowpainter.end() ;
}

void planche :: changeIterationAndGerms(int it,int g) { iterations = it ; nbGerms = g ; }

void planche :: calculateF9(double xm,double xM,double ym,double yM,int iter,int g)
{
 xMin = xm ;
 xMax = xM ;
 yMin = ym ;
 yMax = yM ;
 xMinNew = xMin ;
 xMaxNew = xMax ;
 yMinNew = yMin ;
 yMaxNew = yMax ;
 dx = (xMax-xMin)/sizeX ;
 dy = (yMax-yMin)/sizeX ;
 iterations = iter ;
 nbGerms = g ;
 QApplication::setOverrideCursor(Qt::waitCursor) ;
 calculate() ;
 QApplication::restoreOverrideCursor() ;

 calculateMiniMaxi() ;
 calculateRepartition(repartitionGlobal,mini,maxi ) ;
 emit signalRepartitionMinMaxChanged(repartitionGlobal,mini,maxi) ;

 drawMatrix() ;
 frameCreated = FALSE ;
}

void planche :: changeCoordinate(double xm,double xM,double ym,double yM)
{
 xMin = xm ;
 xMax = xM ;
 yMin = ym ;
 yMax = yM ;
 xMinNew = xMin ;
 xMaxNew = xMax ;
 yMinNew = yMin ;
 yMaxNew = yMax ;
 dx = (xMax-xMin)/sizeX ;
 dy = (yMax-yMin)/sizeX ;

 if (frameCreated)
	{
	 QPainter windowpainter ;
	 QPainter bufferpainter ;

	 windowpainter.begin( this ) ;
	 bufferpainter.begin( &_buffer ) ;
	 windowpainter.setRasterOp( NotXorROP ) ;
	 bufferpainter.setRasterOp( NotXorROP ) ;
	 windowpainter.setPen( blue) ;
	 bufferpainter.setPen( blue ) ;
	 bufferpainter.drawRect(oldPoint.x(),oldPoint.y(),
	 			newPoint.x() - oldPoint.x(),
				newPoint.y() - oldPoint.y()) ;
	 bufferpainter.drawRect(oldPoint.x()-3,oldPoint.y()-3,6,6) ;
	 bufferpainter.drawRect(oldPoint.x()-3,newPoint.y()-3,6,6) ;
	 bufferpainter.drawRect(newPoint.x()-3,oldPoint.y()-3,6,6) ;
	 bufferpainter.drawRect(newPoint.x()-3,newPoint.y()-3,6,6) ;
	 windowpainter.drawRect(oldPoint.x(),oldPoint.y(),
	 			newPoint.x() - oldPoint.x(),
				newPoint.y() - oldPoint.y()) ;
	 windowpainter.drawRect(oldPoint.x()-3,oldPoint.y()-3,6,6) ;
	 windowpainter.drawRect(oldPoint.x()-3,newPoint.y()-3,6,6) ;
	 windowpainter.drawRect(newPoint.x()-3,oldPoint.y()-3,6,6) ;
	 windowpainter.drawRect(newPoint.x()-3,newPoint.y()-3,6,6) ;
	 windowpainter.end() ;
	 bufferpainter.end() ;
	 frameCreated = false ;
	}
}

void planche :: changeSizeMatrix(int s)
{
 if (matrixInteger != NULL ) delete matrixInteger ;
 if (matrixColor != NULL ) delete matrixColor ;
 if (matrixSigma != NULL ) delete matrixSigma ;

 matrixInteger = new int[s*s] ;
 if (matrixInteger == NULL)
	{
	 sizeX = 0 ;
	 return ;
	}
 matrixColor = new unsigned int[s*s] ;
 if (matrixColor == NULL)
	{
	 sizeX = 0 ;
	 delete matrixInteger ;
	 return ;
	}

 matrixSigma = new unsigned int[s*s] ;
 if (matrixColor == NULL)
	{
	 sizeX = 0 ;
	 delete matrixInteger ;
	 delete matrixSigma ;
	 return ;
	}
 sizeX = s ;
 resize( QSize(sizeX,sizeX) );
 _buffer.resize( QSize(sizeX,sizeX) ) ;
}

void planche :: changeEffect(int a)
{
 effetNonLinaire = a ;
 switch(a)
	{
	 case EFFECT_ID_NONE    : _effectFunctionPtr = _effectFunction ; break ;
	 case EFFECT_ID_SLIP    : _effectFunctionPtr = _effectFunctionSlip ;
	 case EFFECT_ID_COMPLEX : _effectFunctionPtr = _effectFunctionComplex ;
	 case EFFECT_ID_V1      : _effectFunctionPtr = _effectFunctionApophysis_1 ;  break ;
	 case EFFECT_ID_V2      : _effectFunctionPtr = _effectFunctionApophysis_2 ;  break ;
	 case EFFECT_ID_V3      : _effectFunctionPtr = _effectFunctionApophysis_3 ;  break ;
	 case EFFECT_ID_V4      : _effectFunctionPtr = _effectFunctionApophysis_4 ;  break ;
	 case EFFECT_ID_V5      : _effectFunctionPtr = _effectFunctionApophysis_5 ;  break ;
	 case EFFECT_ID_V6      : _effectFunctionPtr = _effectFunctionApophysis_6 ;  break ;
	 case EFFECT_ID_V7      : _effectFunctionPtr = _effectFunctionApophysis_7 ;  break ;
	 case EFFECT_ID_V8      : _effectFunctionPtr = _effectFunctionApophysis_8 ;  break ;
	 case EFFECT_ID_V9      : _effectFunctionPtr = _effectFunctionApophysis_9 ;  break ;
	 case EFFECT_ID_V10     : _effectFunctionPtr = _effectFunctionApophysis_10 ;  break ;
	 case EFFECT_ID_V11     : _effectFunctionPtr = _effectFunctionApophysis_11 ;  break ;
	 case EFFECT_ID_V12     : _effectFunctionPtr = _effectFunctionApophysis_12 ;  break ;
	 case EFFECT_ID_V13     : _effectFunctionPtr = _effectFunctionApophysis_13 ;  break ;
	 case EFFECT_ID_W1      : _effectFunctionPtr = _effectFunctionApophysis_n1 ;  break ;
	 case EFFECT_ID_W2      : _effectFunctionPtr = _effectFunctionApophysis_n2 ;  break ;
	 case EFFECT_ID_W3      : _effectFunctionPtr = _effectFunctionApophysis_n3 ;  break ;
	 case EFFECT_ID_W4      : _effectFunctionPtr = _effectFunctionApophysis_n4 ;  break ;
	 case EFFECT_ID_W5      : _effectFunctionPtr = _effectFunctionApophysis_n5 ;  break ;
	 case EFFECT_ID_W6      : _effectFunctionPtr = _effectFunctionApophysis_n6 ;  break ;
	 case EFFECT_ID_W7      : _effectFunctionPtr = _effectFunctionApophysis_n7 ;  break ;
	 case EFFECT_ID_W8      : _effectFunctionPtr = _effectFunctionApophysis_n8 ;  break ;
	 case EFFECT_ID_W9      : _effectFunctionPtr = _effectFunctionApophysis_n9 ;  break ;
	 case EFFECT_ID_W10     : _effectFunctionPtr = _effectFunctionApophysis_n10 ;  break ;
	 case EFFECT_ID_W11     : _effectFunctionPtr = _effectFunctionApophysis_n11 ;  break ;
	 case EFFECT_ID_W12     : _effectFunctionPtr = _effectFunctionApophysis_n12 ;  break ;
	 case EFFECT_ID_W13     : _effectFunctionPtr = _effectFunctionApophysis_n13 ;  break ;
	 default : _effectFunctionPtr = _effectFunction ;
	}
 }

void planche :: changeEffectColor(int a)
{
 effetCouleur = a ;
 switch(a)
	{
	 case EFFECT_COLOR_ID_NONE     : _effectColorPtr = _effectColor ; break ;
	 case EFFECT_COLOR_ID_LOG      : _effectColorPtr = _effectColorLog ; break ;
	 case EFFECT_COLOR_ID_GAMMA    : _effectColorPtr = _effectColorGamma ; break ;
	 case EFFECT_COLOR_ID_RELIEF   : _effectColorPtr = _effectColorRelief ; break ;
	 case EFFECT_COLOR_ID_CONTRAST : _effectColorPtr = _effectColorContrast ; break ;
	}
}

void planche :: loadPalette(QString f)
{
 int i,r,g,b,nbC ;
 char ch[9] ;

 ifstream entreeText( f.latin1()  , ios::in ) ;

 if (entreeText)
 	{
	 entreeText.getline(ch,8) ;
	 if (not(entreeText.eof()))
		{
		 nbC = atol(ch) ;
		 if ((nbC>0) && (nbC<100000))
			{
			 delete palette.colors ;
			 palette.colors = new unsigned int[nbC] ;
			 palette.nbColors = nbC ;
			 for(i=0;i<nbC;i++)
				{
				 entreeText.getline(ch,8) ;
				 if (entreeText.eof()) break ;
				 string2RGB( ch,&r,&g,&b ) ;
				 g <<= 8 ;
				 b <<= 16 ;
				 r += (g+b) ;
				 palette.colors[i] = r ;
				}
			  drawMatrix() ;
			}
		}
	}
}

paletteRGB* planche :: getPalette() { return &palette ; }

void planche :: saveImage(QString f)
{
 QString nb ;
 int i,ii ;

 if ( !_buffer.save( f+".bmp", "BMP") )
 		QMessageBox::warning(0,"Erreur d'enregistrement" ,
					"impossible d'enregistrer le fichier") ;


 QFile file( f+".txt" ) ;
 if (file.open( IO_WriteOnly ))
	{
	 QTextStream stream( &file ) ;
	 stream << "[Scope] [Precision] [Xmin,Xmax,Ymin,Ymax]" << endl ;
	 stream << "16" << endl ;
	 stream << nb.setNum( xMin,'g',16) << endl ;
	 stream << nb.setNum( xMax,'g',16) << endl ;
	 stream << nb.setNum( yMin,'g',16) << endl ;
	 stream << nb.setNum( yMax,'g',16) << endl ;
	 stream << "[type]" << endl ;
	 stream << "pseudo-linear IFS" << endl ;
	 stream << "[Parameter] [nbIFS,(a,b,c,d,e,f,w)*nbIFS,function] * " << endl ;
	 stream << nb.setNum( nbIFS ) << endl ;
	 for(i=0;i<nbIFS;i++)
		{
		 ii = 10*i ;
		 stream << nb.setNum( ifs[ii],'g',16) << endl ;
		 stream << nb.setNum( ifs[ii+1],'g',16) << endl ;
		 stream << nb.setNum( ifs[ii+2],'g',16) << endl ;
		 stream << nb.setNum( ifs[ii+3],'g',16) << endl ;
		 stream << nb.setNum( ifs[ii+4],'g',16) << endl ;
		 stream << nb.setNum( ifs[ii+5],'g',16) << endl ;
		 stream << nb.setNum( ifs[ii+6],'g',16) << endl ;
		}
	 file.close() ;
	}

}

void planche :: changeAlgorithmColoration(int a)
{
 algorithm_coloration = a ;
}

void planche :: draw3D(double xm,double xM,double ym,double yM,double zm,double zM,
			int format,int typeAltitude,QString nom)
{

 int i,j,a,sizeX1,k,nbco,b,c ;
 unsigned int co ;
 double yaux,dxf,dyf,dzf,xaux,zaux;

 //cout << xm << endl ;
 //cout << xM << endl ;
 //cout << ym << endl ;
 //cout << yM << endl ;
 //cout << zm << endl ;
 //cout << zM << endl ;
 //cout << nom << endl ;

 nbco = palette.nbColors  ;
 dxf = (xM - xm)/sizeX ;
 dyf = (yM - ym)/sizeX ;
 i = maxi - mini ;
 if (i ==0 ) i = 1 ;
 switch(typeAltitude)
	{
	 case 0 : if (i != 0) dzf = (zM - zm)/i ; else  dzf = 0.0 ; break ; // linaire
	 case 1 : if (i != 0) dzf = (zM - zm)/log(i+1.0) ; else  dzf = 0.0 ; break ; // log
	 case 2 : if (i != 0) dzf = (zM - zm)/log(log(i+3.0)) ; else  dzf = 0.0 ; break ; // log log
	 default : dzf = 0.0 ;
	}

 QApplication::setOverrideCursor(Qt::waitCursor) ;

 cout << " format = " << format << endl ;

 if (format== FORMAT_ID_VIDEOSCAPE)  // problem with switch et QFile ???
	{
 	  QFile file( nom+".obj" ) ;
 	  if (file.open( IO_WriteOnly ))
		{
		 QTextStream stream( &file ) ;
		 stream << "3DG1" << endl ;
		 stream << sizeX*sizeX << endl ;
		 switch(typeAltitude)
		 	{
		 	 case 0 : for( i = 0 ; i < sizeX ; i++ )
					{
					 yaux = yM - i * dyf ;
					 for( j = 0 ; j < sizeX ; j++ )
						{
						 xaux = xm + j * dxf ;
						 a = matrixInteger[i*sizeX+j] ;
						 zaux = zm + (a-mini) * dzf ;
						 stream << xaux << " "
					        << yaux << " " << zaux << endl ;
						}
					}
				 break ;
			 case 1 : for( i = 0 ; i < sizeX ; i++ )
					{
					 yaux = ym + i * dyf ;
					 for( j = 0 ; j < sizeX ; j++ )
						{
						 xaux = xm + j * dxf ;
						 a = matrixInteger[i*sizeX+j] ;
						 zaux = log(a-mini+1.0) ;
						 zaux = zm + zaux * dzf ;
						 stream <<  xaux << " "
					        << yaux << " " << zaux  << endl ;
						}
					}
				 break ;
		 	 case 2 : for( i = 0 ; i < sizeX ; i++ )
					{
					 yaux = ym + i * dyf ;
					 for( j = 0 ; j < sizeX ; j++ )
						{
						 xaux = xm + j * dxf ;
						 a = matrixInteger[i*sizeX+j] ;
						 zaux = log(log(a-mini+3.0)) ;
						 zaux = zm + zaux * dzf ;
						 stream << xaux << " "
						        << yaux << " " << zaux << endl ;
						}
					}
				 break ;
			}
		 sizeX1 = sizeX - 1 ;
		 for(i=0;i<sizeX1;i++)
			 for(j=0;j<sizeX1;j++)
				{
				 // triangle infrieur
				 a = sizeX*i+j+1   ; // indice (i,j)
				 b = sizeX*i+j+2 ; // indice (i,j+1)
				 c = sizeX*i+sizeX+j+1 ; // indice (i+1,j)
				 stream  << "3 " << a << " " << b << " " << c << " 0x808080" << endl ;
				 // triangle suprieur
				 a = sizeX*i+j+sizeX+2 ; // indice (i+1,j+1)
				 b = sizeX*i+j+2   ; // indice (i,j+1)
				 c = sizeX*i+sizeX+j+1   ; // indice (i+1,j)
				 stream << "3 " << a << " " << b << " " << c <<  " 0x808080" << endl ;
				}
		 file.close() ;
		}// file.open
	}

 if (format== FORMAT_ID_SGML)  // problem with switch et QFile ???
	{
 	  QFile file( nom+".3db" ) ;
 	  if (file.open( IO_WriteOnly ))
		{
		 QTextStream stream( &file ) ;
		 stream << "<points3D>" << endl ;
		 k= 0 ;
		 switch(typeAltitude)
		 	{
		 	 case 0 : for( i = 0 ; i < sizeX ; i++ )
					{
					 yaux = yM - i * dyf ;
					 for( j = 0 ; j < sizeX ; j++ )
						{
						 xaux = xm + j * dxf ;
						 k++ ;
						 a = matrixInteger[i*sizeX+j] ;
						 zaux = zm + (a-mini) * dzf ;
						 stream << k << ", " << xaux << ","
						        << yaux << "," << zaux << endl ;
						}
					}
				 break ;
			 case 1 : for( i = 0 ; i < sizeX ; i++ )
					{
					 yaux = ym + i * dyf ;
					 for( j = 0 ; j < sizeX ; j++ )
						{
						 xaux = xm + j * dxf ;
						 k++ ;
						 a = matrixInteger[i*sizeX+j] ;
						 zaux = log(a-mini+1.0) ;
						 zaux = zm + zaux * dzf ;
						  stream << k << ", " << xaux << ","
						         << yaux << "," << zaux << endl ;
						}
					}
				 break ;
		 	 case 2 : for( i = 0 ; i < sizeX ; i++ )
					{
					 yaux = ym + i * dyf ;
					 for( j = 0 ; j < sizeX ; j++ )
						{
						 xaux = xm + j * dxf ;
						 k++ ;
						 a = matrixInteger[i*sizeX+j] ;
						 zaux = log(log(a-mini+3.0)) ;
						 zaux = zm + zaux * dzf ;
						 stream << k << ", " << xaux << ","
						        << yaux << "," << zaux << endl ;
						}
					}
				 break ;
			}

		 sizeX1 = sizeX - 1 ;
		 stream << "</points3D>" << endl ;
		 stream << "<faces>" << endl ;
		 for(i=0;i<sizeX1;i++)
			 for(j=0;j<sizeX1;j++)
				{
				 // triangle infrieur
				 a = sizeX*i+j+1   ; // indice (i,j)
				 b = sizeX*i+j+2 ; // indice (i,j+1)
				 c = sizeX*i+sizeX+j+1 ; // indice (i+1,j)
				 stream  << a << "," << b << "," << c << endl ;
				 // triangle suprieur
				 a = sizeX*i+j+sizeX+2 ; // indice (i+1,j+1)
				 b = sizeX*i+j+2   ; // indice (i,j+1)
				 c = sizeX*i+sizeX+j+1   ; // indice (i+1,j)
				 stream << a << "," << b << "," << c << endl ;
				}
		 stream << "</faces>" << endl ;
		 file.close() ;
		}// file.open
	}

 if (format== FORMAT_ID_POV_RAY)
	{
	 QFile file( nom+".pov" ) ;
	 if (file.open( IO_WriteOnly ))
		{
		 QTextStream stream( &file ) ;
		 stream << "mesh2 {" << endl ;
		 stream << "\t vertex_vectors {" << endl ;
		 stream << "\t \t " << sizeX*sizeX << "," << endl ;
		 switch(typeAltitude)
		 	{
		 	 case 0 : for( i = 0 ; i < sizeX ; i++ )
					{
					 yaux = yM - i * dyf ;
					 for( j = 0 ; j < sizeX ; j++ )
						{
						 xaux = xm + j * dxf ;
						 k++ ;
						 a = matrixInteger[i*sizeX+j] ;
						 zaux = zm + (a-mini) * dzf ;
						 stream << "\t\t <" << xaux << ","
						        << zaux << "," << yaux << ">" << endl ;
						}
					}
				 break ;
			 case 1 : for( i = 0 ; i < sizeX ; i++ )
					{
					 yaux = ym + i * dyf ;
					 for( j = 0 ; j < sizeX ; j++ )
						{
						 xaux = xm + j * dxf ;
						 k++ ;
						 a = matrixInteger[i*sizeX+j] ;
						 zaux = log(a-mini+1.0) ;
						 zaux = zm + zaux * dzf ;
						  stream << "\t\t <" << xaux << ","
						        << zaux << "," << yaux << ">" << endl ;
						}
					}
				 break ;
		 	 case 2 : for( i = 0 ; i < sizeX ; i++ )
					{
					 yaux = ym + i * dyf ;
					 for( j = 0 ; j < sizeX ; j++ )
						{
						 xaux = xm + j * dxf ;
						 k++ ;
						 a = matrixInteger[i*sizeX+j] ;
						 zaux = log(log(a-mini+3.0)) ;
						 zaux = zm + zaux * dzf ;
						 stream << "\t\t <" << xaux << ","
						        << zaux << "," << yaux << ">" << endl ;
						}
					}
				 break ;
			}
		 stream << "\t }" << endl ;
		 /*
		 stream << "\t texture_list {" << endl ;
		 stream << "\t \t " << nbco << "," << endl ;
		 for(i=0;i<nbco;i++)
			{
			 a = palette.colors[i] ;
			 xaux = (a & MASK_COLOR) * 3.92156862745e-3 ;
			 yaux = ((a>> 8) & MASK_COLOR) * 3.92156862745e-3 ;
			 zaux = ((a>> 16) & MASK_COLOR) * 3.92156862745e-3 ;
			 stream << "\t \t texture{pigment{ rgb <" << xaux << ","
			 	<< yaux << "," << zaux << ">}}" << endl ;
			}
		 stream << "\t }" << endl ;
		 */
		 sizeX1 = sizeX - 1 ;
		 stream << "\t face_indices {" << endl ;
		 stream << "\t \t " << 2*sizeX1*sizeX1 << "," << endl ;
		 for(i=0;i<sizeX1;i++)
			 for(j=0;j<sizeX1;j++)
				{
				 //co = matrixColor[i*sizeX+j] ;
				 // triangle infrieur
				 a = sizeX*i+j   ; // indice (i,j)
				 b = sizeX*i+j+1 ; // indice (i,j+1)
				 c = sizeX*i+sizeX+j ; // indice (i+1,j)
				 //stream << "\t\t <" << a << "," << b << "," << c << ">," << co << "," <<endl ;
				 stream << "\t\t <" << a << "," << b << "," << c << ">," << endl ;
				 // triangle suprieur
				 a = sizeX*i+j+sizeX+1 ; // indice (i+1,j+1)
				 b = sizeX*i+j+1   ; // indice (i,j+1)
				 c = sizeX*i+sizeX+j   ; // indice (i+1,j)
				 //stream << "\t\t <" << a << "," << b << "," << c << ">," << co << "," << endl ;
				 stream << "\t\t <" << a << "," << b << "," << c << ">," << endl ;
				}
		 stream << "\t }" << endl ;
		 stream << "}" << endl ;
		 file.close() ;
		} // file.open
	}
 QApplication::restoreOverrideCursor() ;

}

void planche :: mouseDoubleClickEvent( QMouseEvent* e)
{
 //QString sXmin, sXmax , sYmin ,sYmax , sIter ;
 //bool ok ;


 if (frameCreated)
	{
	 if (fabs(xMin-xMinNew)+fabs(xMax-xMaxNew)+fabs(yMin-yMinNew)+fabs(yMax-yMaxNew) >= EPSILON)
		{
		 xMin = xMinNew ;
		 xMax = xMaxNew ;
		 yMin = yMinNew ;
		 yMax = yMaxNew ;
		}
	}
	else
	{
	/*
	 _frame->getEdit(&sXmin, &sXmax , &sYmin ,&sYmax) ;
	 xMin = sXmin.toDouble(&ok) ;
	 xMax = sXmax.toDouble(&ok) ;
	 yMin = sYmin.toDouble(&ok) ;
	 yMax = sYmax.toDouble(&ok) ;
	 //cout << xMin << " " << xMax << " : " << yMin << " " << yMax << "\n" ;
	 if (fabs(xMin-coord[currentCoord][0])+
	     fabs(xMax-coord[currentCoord][1])+
	     fabs(yMin-coord[currentCoord][2])+
	     fabs(yMax-coord[currentCoord][3]) >= EPSILON)
		{
		 currentCoord++ ;
		 coord[currentCoord][0] = xMin ;
		 coord[currentCoord][1] = xMax ;
		 coord[currentCoord][2] = yMin ;
		 coord[currentCoord][3] = yMax ;
		}
	 */
	}

 dx = (xMax-xMin)/sizeX ;
 dy = (yMax-yMin)/sizeX ;
 QApplication::setOverrideCursor(Qt::waitCursor) ;
 calculate() ;
 QApplication::restoreOverrideCursor() ;
 if (matrixInteger!=NULL)
	{
	 calculateMiniMaxi() ;
	 //miniReal = mini ;
	 //maxiReal = maxi ;
	 calculateRepartition(repartitionGlobal,mini,maxi ) ;
	 emit signalRepartitionMinMaxChanged(repartitionGlobal,mini,maxi) ;
	}

 drawMatrix() ;
 frameCreated = FALSE ;

 emit signalFrameChanged(xMin,xMax,yMin,yMax) ;
}


void planche :: mousePressEvent( QMouseEvent* event )
{
 int XXinf , XXsup , YYinf , YYsup , X , Y ;

 if ( oldPoint.x() < newPoint.x() )
 	{
	 XXinf = oldPoint.x() ;
	 XXsup = newPoint.x() ;
	}
	else
	{
	 XXinf = newPoint.x() ;
	 XXsup = oldPoint.x() ;
	}
 if ( oldPoint.y() < newPoint.y() )
 	{
	 YYinf = oldPoint.y() ;
	 YYsup = newPoint.y() ;
	}
	else
	{
	 YYinf = newPoint.y() ;
	 YYsup = oldPoint.y() ;
	}
 X = event->x() ;
 Y = event->y() ;

 if (( XXinf <= X ) && ( X <= XXsup ) &&
     ( YYinf <= Y ) && ( Y <= YYsup ))
    overallMvt = TRUE ; else overallMvt = FALSE ;

 if ((event->button() == LeftButton ) && not(frameCreated))
 	{
	 oldPoint = event->pos() ;
	 xMinNew = xMin + dx * X ;
	 yMinNew = yMax - dy * Y ;
	}


 if (( X >= oldPoint.x()-3 ) && ( X <= oldPoint.x()+3 ) &&
     ( Y >= oldPoint.y()-3 ) && ( Y <= oldPoint.y()+3 ) ) frameChanged = 1 ;
 if (( X >= newPoint.x()-3 ) && ( X <= newPoint.x()+3 ) &&
     ( Y >= oldPoint.y()-3 ) && ( Y <= oldPoint.y()+3 ) ) frameChanged = 2 ;
 if (( X >= newPoint.x()-3 ) && ( X <= newPoint.x()+3 ) &&
     ( Y >= newPoint.y()-3 ) && ( Y <= newPoint.y()+3 ) ) frameChanged = 3 ;
 if (( X >= oldPoint.x()-3 ) && ( X <= oldPoint.x()+3 ) &&
     ( Y >= newPoint.y()-3 ) && ( Y <= newPoint.y()+3 ) ) frameChanged = 4 ;

 if ( frameChanged > -1 ) overallMvt = FALSE ;
 mvtPoint = event->pos() ;
 typeButtonPressed = event->button() ;
}


void planche :: mouseReleaseEvent( QMouseEvent* event )
{
 double Aux ;
 int X , Y , Xo , Yo ;

 X = event->x() ;
 Y = event->y() ;
 Xo = oldPoint.x() ;
 Yo = oldPoint.y() ;
 if (( typeButtonPressed == LeftButton ) && not(frameCreated))
 	{
	 if ((X>=Xo-3) && (X<=Xo+3) && (Y>=Yo-3) && (Y<=Yo+3))
	 	{
		 frameCreated = FALSE ;
		}
		else
		{
	 	 newPoint = event->pos() ;
	 	 frameCreated = TRUE ;
		 xMaxNew = xMin + dx * X ;
		 yMaxNew = yMax - dy * Y ;
		 if ( xMinNew > xMaxNew )
			{
			 Aux = xMinNew ;
		 	 xMinNew = xMaxNew ;
		 	 xMaxNew = Aux ;
			}
		 if ( yMinNew > yMaxNew )
			{
		 	 Aux = yMinNew ;
		 	 yMinNew = yMaxNew ;
		 	 yMaxNew = Aux ;
			}
		 //emit signalFrameChanged(xMinNew,xMaxNew,yMinNew,yMaxNew) ;
		}
	}

 frameChanged = -1 ;
 typeButtonPressed = NoButton ;
}


void planche :: mouseMoveEvent( QMouseEvent* event )
{
 QPainter windowpainter ;
 QPainter bufferpainter ;
 int X , Y , ax , ay ;
 //double xAux , yAux ;

 X = event->x() ;
 Y = event->y() ;
 windowpainter.begin( this ) ;
 bufferpainter.begin( &_buffer ) ;
 windowpainter.setRasterOp( NotXorROP ) ;
 bufferpainter.setRasterOp( NotXorROP ) ;
 windowpainter.setPen( blue) ;
 bufferpainter.setPen( blue ) ;

 if ( (typeButtonPressed == LeftButton) && not(frameCreated))
	{
	 bufferpainter.drawRect(oldPoint.x(),oldPoint.y(),
	 			mvtPoint.x() - oldPoint.x(),
				mvtPoint.y() - oldPoint.y()) ;
	 bufferpainter.drawRect(oldPoint.x()-3,oldPoint.y()-3,6,6) ;
	 bufferpainter.drawRect(oldPoint.x()-3,mvtPoint.y()-3,6,6) ;
	 bufferpainter.drawRect(mvtPoint.x()-3,oldPoint.y()-3,6,6) ;
	 bufferpainter.drawRect(mvtPoint.x()-3,mvtPoint.y()-3,6,6) ;
	 windowpainter.drawRect(oldPoint.x(),oldPoint.y(),
	 			mvtPoint.x() - oldPoint.x(),
				mvtPoint.y() - oldPoint.y()) ;
	 windowpainter.drawRect(oldPoint.x()-3,oldPoint.y()-3,6,6) ;
	 windowpainter.drawRect(oldPoint.x()-3,mvtPoint.y()-3,6,6) ;
	 windowpainter.drawRect(mvtPoint.x()-3,oldPoint.y()-3,6,6) ;
	 windowpainter.drawRect(mvtPoint.x()-3,mvtPoint.y()-3,6,6) ;
	 mvtPoint = event->pos() ;
	 bufferpainter.drawRect(oldPoint.x(),oldPoint.y(),
	 			mvtPoint.x() - oldPoint.x(),
				mvtPoint.y() - oldPoint.y()) ;
	 bufferpainter.drawRect(oldPoint.x()-3,oldPoint.y()-3,6,6) ;
	 bufferpainter.drawRect(oldPoint.x()-3,mvtPoint.y()-3,6,6) ;
	 bufferpainter.drawRect(mvtPoint.x()-3,oldPoint.y()-3,6,6) ;
	 bufferpainter.drawRect(mvtPoint.x()-3,mvtPoint.y()-3,6,6) ;
	 windowpainter.drawRect(oldPoint.x(),oldPoint.y(),
	 			mvtPoint.x() - oldPoint.x(),
				mvtPoint.y() - oldPoint.y()) ;
	 windowpainter.drawRect(oldPoint.x()-3,oldPoint.y()-3,6,6) ;
	 windowpainter.drawRect(oldPoint.x()-3,mvtPoint.y()-3,6,6) ;
	 windowpainter.drawRect(mvtPoint.x()-3,oldPoint.y()-3,6,6) ;
	 windowpainter.drawRect(mvtPoint.x()-3,mvtPoint.y()-3,6,6) ;
	 //xMaxNew = xMax + dx * mvtPoint.x() ;
	 //yMaxNew = yMax -  dy * mvtPoint.y() ;
	}
if ((typeButtonPressed == LeftButton) && overallMvt && frameCreated)
	{
	 bufferpainter.drawRect(oldPoint.x(),oldPoint.y(),
	 			newPoint.x() - oldPoint.x(),
				newPoint.y() - oldPoint.y()) ;
	 bufferpainter.drawRect(oldPoint.x()-3,oldPoint.y()-3,6,6) ;
	 bufferpainter.drawRect(oldPoint.x()-3,newPoint.y()-3,6,6) ;
	 bufferpainter.drawRect(newPoint.x()-3,oldPoint.y()-3,6,6) ;
	 bufferpainter.drawRect(newPoint.x()-3,newPoint.y()-3,6,6) ;
	 windowpainter.drawRect(oldPoint.x(),oldPoint.y(),
	 			newPoint.x() - oldPoint.x(),
				newPoint.y() - oldPoint.y()) ;
	 windowpainter.drawRect(oldPoint.x()-3,oldPoint.y()-3,6,6) ;
	 windowpainter.drawRect(oldPoint.x()-3,newPoint.y()-3,6,6) ;
	 windowpainter.drawRect(newPoint.x()-3,oldPoint.y()-3,6,6) ;
	 windowpainter.drawRect(newPoint.x()-3,newPoint.y()-3,6,6) ;
	 ax = X - mvtPoint.x() ;
	 ay = Y - mvtPoint.y() ;
	 mvtPoint = event->pos() ;
	 oldPoint.setX(oldPoint.x() + ax) ;
	 oldPoint.setY(oldPoint.y() + ay) ;
	 newPoint.setX(newPoint.x() + ax) ;
	 newPoint.setY(newPoint.y() + ay) ;
	 bufferpainter.drawRect(oldPoint.x(),oldPoint.y(),
	 			newPoint.x() - oldPoint.x(),
				newPoint.y() - oldPoint.y()) ;
	 bufferpainter.drawRect(oldPoint.x()-3,oldPoint.y()-3,6,6) ;
	 bufferpainter.drawRect(oldPoint.x()-3,newPoint.y()-3,6,6) ;
	 bufferpainter.drawRect(newPoint.x()-3,oldPoint.y()-3,6,6) ;
	 bufferpainter.drawRect(newPoint.x()-3,newPoint.y()-3,6,6) ;
	 windowpainter.drawRect(oldPoint.x(),oldPoint.y(),
	 			newPoint.x() - oldPoint.x(),
				newPoint.y() - oldPoint.y()) ;
	 windowpainter.drawRect(oldPoint.x()-3,oldPoint.y()-3,6,6) ;
	 windowpainter.drawRect(oldPoint.x()-3,newPoint.y()-3,6,6) ;
	 windowpainter.drawRect(newPoint.x()-3,oldPoint.y()-3,6,6) ;
	 windowpainter.drawRect(newPoint.x()-3,newPoint.y()-3,6,6) ;
	 xMinNew += ax * dx ;
	 yMinNew -= ay * dy ;
	 xMaxNew += ax * dx ;
	 yMaxNew -= ay * dy ;
	 //emit signalFrameChanged(xMinNew,xMaxNew,yMinNew,yMaxNew) ;
	}

 if ((typeButtonPressed == LeftButton) && frameCreated && (frameChanged != -1) )
	{
	 bufferpainter.drawRect(oldPoint.x(),oldPoint.y(),
	 			newPoint.x() - oldPoint.x(),
				newPoint.y() - oldPoint.y()) ;
	 bufferpainter.drawRect(oldPoint.x()-3,oldPoint.y()-3,6,6) ;
	 bufferpainter.drawRect(oldPoint.x()-3,newPoint.y()-3,6,6) ;
	 bufferpainter.drawRect(newPoint.x()-3,oldPoint.y()-3,6,6) ;
	 bufferpainter.drawRect(newPoint.x()-3,newPoint.y()-3,6,6) ;
	 windowpainter.drawRect(oldPoint.x(),oldPoint.y(),
	 			newPoint.x() - oldPoint.x(),
				newPoint.y() - oldPoint.y()) ;
	 windowpainter.drawRect(oldPoint.x()-3,oldPoint.y()-3,6,6) ;
	 windowpainter.drawRect(oldPoint.x()-3,newPoint.y()-3,6,6) ;
	 windowpainter.drawRect(newPoint.x()-3,oldPoint.y()-3,6,6) ;
	 windowpainter.drawRect(newPoint.x()-3,newPoint.y()-3,6,6) ;
	 //mvtPoint = event->pos() ; // ????
	 switch (frameChanged)
	 	{
		 case 1 : oldPoint = event->pos() ;
		 	  break ;
		 case 2 : newPoint.setX( X ) ;
		 	  oldPoint.setY( Y ) ;
			  break ;
		 case 3 : newPoint = event->pos() ;
		 	  break ;
		 case 4 : oldPoint.setX( X ) ;
		 	  newPoint.setY( Y ) ;
			  break ;
		}
	 bufferpainter.drawRect(oldPoint.x(),oldPoint.y(),
	 			newPoint.x() - oldPoint.x(),
				newPoint.y() - oldPoint.y()) ;
	 bufferpainter.drawRect(oldPoint.x()-3,oldPoint.y()-3,6,6) ;
	 bufferpainter.drawRect(oldPoint.x()-3,newPoint.y()-3,6,6) ;
	 bufferpainter.drawRect(newPoint.x()-3,oldPoint.y()-3,6,6) ;
	 bufferpainter.drawRect(newPoint.x()-3,newPoint.y()-3,6,6) ;
	 windowpainter.drawRect(oldPoint.x(),oldPoint.y(),
	 			newPoint.x() - oldPoint.x(),
				newPoint.y() - oldPoint.y()) ;
	 windowpainter.drawRect(oldPoint.x()-3,oldPoint.y()-3,6,6) ;
	 windowpainter.drawRect(oldPoint.x()-3,newPoint.y()-3,6,6) ;
	 windowpainter.drawRect(newPoint.x()-3,oldPoint.y()-3,6,6) ;
	 windowpainter.drawRect(newPoint.x()-3,newPoint.y()-3,6,6) ;
	 if (oldPoint.x()< newPoint.x())
		{X = oldPoint.x(); ax = newPoint.x();}
		else
		{X = newPoint.x(); ax = oldPoint.x();}
	 if (oldPoint.y()< newPoint.y())
		{Y = oldPoint.y(); ay = newPoint.y();}
		else
		{Y = newPoint.y(); ay = oldPoint.y();}
	 xMinNew = xMin + dx * X ;
	 yMinNew = yMax - dy * ay ;
	 xMaxNew = xMin + dx * ax ;
	 yMaxNew = yMax - dy * Y ;
	 //emit signalFrameChanged(xMinNew,xMaxNew,yMinNew,yMaxNew) ;
	}

 windowpainter.end() ;
 bufferpainter.end() ;
 //bitBlt( this , 0 , 0 , &_buffer ) ;
}

void planche :: paintEvent( QPaintEvent* event )
{
 bitBlt( this , 0 , 0 , &_buffer ) ;
}

