#ifndef PLANCHE_H
#define PLANCHE_H

using namespace std ;
#include <iostream>
#include <cmath>

#include <qwidget.h>
#include <qpainter.h>
#include <qpixmap.h>
#include <qstring.h>

#include "constants.h"

class QColor ;

class effectColor ;
class effectColorGamma ;
class effectColorRelief ;
class effectColorLog ;
class effectColorContrast ;
class sparam ;
class effectFunction ;
class effectFunctionSlip ;
class effectFunctionComplex ;
class effectFunctionApophysis_1 ;
class effectFunctionApophysis_2 ;
class effectFunctionApophysis_3 ;
class effectFunctionApophysis_4 ;
class effectFunctionApophysis_5 ;
class effectFunctionApophysis_6 ;
class effectFunctionApophysis_7 ;
class effectFunctionApophysis_8 ;
class effectFunctionApophysis_9 ;
class effectFunctionApophysis_10 ;
class effectFunctionApophysis_11 ;
class effectFunctionApophysis_12 ;
class effectFunctionApophysis_13 ;
class effectFunctionApophysis_n1 ;
class effectFunctionApophysis_n2 ;
class effectFunctionApophysis_n3 ;
class effectFunctionApophysis_n4 ;
class effectFunctionApophysis_n5 ;
class effectFunctionApophysis_n6 ;
class effectFunctionApophysis_n7 ;
class effectFunctionApophysis_n8 ;
class effectFunctionApophysis_n9 ;
class effectFunctionApophysis_n10 ;
class effectFunctionApophysis_n11 ;
class effectFunctionApophysis_n12 ;
class effectFunctionApophysis_n13 ;


class planche : public QWidget
{
   Q_OBJECT

 public :
  planche( QWidget*,const char*,WFlags ) ;  // constructeur
  ~planche() ;
  void setPaletteRGB( unsigned int*,int) ;
  void setFrame(double,double,double,double) ;
  void calculate() ;
  void calculateF9(double,double,double,double,int,int) ;
  void changeParameterColoration(parameterColoration*) ;
  void drawMatrix() ;
  void changeIterationAndGerms(int,int ) ;
  void changeAlgorithmColoration(int) ;
  void calculateMiniMaxi() ;
  //void changeKappa(double ) ;
  void calculateRepartition(int*,int,int) ;
  void changeCoordinate(double,double,double,double) ;
  void changeIFS(paralleVector*,int,int ) ;
  void changeSizeMatrix(int) ;
  void loadPalette(QString f) ;
  paletteRGB* getPalette() ;
  void saveImage(QString f) ;
  void changeEffect(int) ;
  void changeEffectColor(int) ;
  void draw3D(double,double,double,double,double,double,int,int,QString) ;
  void getMinMax(int*,int*) ;
  int getSize() ;
  int* getMatrixLong() ;
  unsigned int* getMatrixColor() ;
  void changeParameterEffectColor( sparam* ) ;
  void changeParameterEffect( sparam* ) ;

 signals :
  void signalFrameChanged(double,double,double,double) ;
  void signalRepartitionMinMaxChanged(int*,int,int) ;
  void signalDelay(double) ;

 protected :
  virtual void mouseDoubleClickEvent( QMouseEvent* ) ;
  virtual void mousePressEvent( QMouseEvent* ) ;
  virtual void mouseReleaseEvent( QMouseEvent* ) ;
  virtual void mouseMoveEvent( QMouseEvent* ) ;
  virtual void paintEvent( QPaintEvent* ) ;

 private :
   unsigned int colorCentraleZone(int,int,double) ;
   unsigned int colorLowZone(int,int,int,int,double) ;
   unsigned int colorHighZone(int,int,int,int,double) ;

 private :
  QPixmap _buffer ;
  double xMin,xMax,yMin,yMax,dx,dy,xMinNew,xMaxNew,yMinNew,yMaxNew ;
  int repartitionGlobal[SIZE_IMAGE_REPARTITION_X] ;
  paletteRGB palette ;
  int sizeX,mini,maxi,nbIFS,iterations,nbGerms,algorithm_coloration ;
  parameterColoration _parameterColoration ;
  int effetCouleur,effetNonLinaire ;
  int* matrixInteger ;
  unsigned int* matrixColor ;
  unsigned int* matrixSigma ;
  double* ifs ;
  // Effet sur les couleurs
  effectColor* _effectColorPtr ;
  effectColor* _effectColor ;
  effectColorGamma* _effectColorGamma ;
  effectColorRelief* _effectColorRelief ;
  effectColorLog* _effectColorLog ;
  effectColorContrast* _effectColorContrast ;
  // Effet sur les fonctions
  effectFunction* _effectFunctionPtr ;
  effectFunction* _effectFunction ;
  effectFunctionSlip* _effectFunctionSlip ;
  effectFunctionComplex* _effectFunctionComplex ;
  effectFunctionApophysis_1* _effectFunctionApophysis_1 ;
  effectFunctionApophysis_2* _effectFunctionApophysis_2 ;
  effectFunctionApophysis_3* _effectFunctionApophysis_3 ;
  effectFunctionApophysis_4* _effectFunctionApophysis_4 ;
  effectFunctionApophysis_5* _effectFunctionApophysis_5 ;
  effectFunctionApophysis_6* _effectFunctionApophysis_6 ;
  effectFunctionApophysis_7* _effectFunctionApophysis_7 ;
  effectFunctionApophysis_8* _effectFunctionApophysis_8 ;
  effectFunctionApophysis_9* _effectFunctionApophysis_9 ;
  effectFunctionApophysis_10* _effectFunctionApophysis_10 ;
  effectFunctionApophysis_11* _effectFunctionApophysis_11 ;
  effectFunctionApophysis_12* _effectFunctionApophysis_12 ;
  effectFunctionApophysis_13* _effectFunctionApophysis_13 ;
  effectFunctionApophysis_n1* _effectFunctionApophysis_n1 ;
  effectFunctionApophysis_n2* _effectFunctionApophysis_n2 ;
  effectFunctionApophysis_n3* _effectFunctionApophysis_n3 ;
  effectFunctionApophysis_n4* _effectFunctionApophysis_n4 ;
  effectFunctionApophysis_n5* _effectFunctionApophysis_n5 ;
  effectFunctionApophysis_n6* _effectFunctionApophysis_n6 ;
  effectFunctionApophysis_n7* _effectFunctionApophysis_n7 ;
  effectFunctionApophysis_n8* _effectFunctionApophysis_n8 ;
  effectFunctionApophysis_n9* _effectFunctionApophysis_n9 ;
  effectFunctionApophysis_n10* _effectFunctionApophysis_n10 ;
  effectFunctionApophysis_n11* _effectFunctionApophysis_n11 ;
  effectFunctionApophysis_n12* _effectFunctionApophysis_n12 ;
  effectFunctionApophysis_n13* _effectFunctionApophysis_n13 ;
  // gestion de la slection
  QPoint oldPoint , newPoint , mvtPoint ;
  bool frameCreated , overallMvt ;
  int typeButtonPressed ;
  int frameChanged ;
} ;

#endif
