#ifndef QDOUBLESLIDER_H
#define QDOUBLESLIDER_H

using namespace std ;
#include <iostream>
#include <cmath>

#include <qwidget.h>
#include <qpainter.h>
#include <qpointarray.h>


class QDoubleSlider : public QWidget
{
   Q_OBJECT

 public :
  QDoubleSlider( QWidget* parent=0,const char* name=0,WFlags f=0 ) ;  // constructeur
  QDoubleSlider( int minValue, int maxValue, int value1, int value2, QWidget* parent,const char* name,WFlags f ) ;
  virtual ~QDoubleSlider() ;
  int minValue() const ;
  int maxValue() const ;
  void setMinValue( int) ;
  void setMaxValue( int) ;
  int value1() ;
  int value2() ;
  void values( int*,int* ) ;

 public slots :
  virtual void setValue1( int) ;
  virtual void setValue2( int) ;
  virtual void setValues( int,int) ;

 signals :
  void valuesChanged( int,int ) ;

 protected :
  virtual void mousePressEvent( QMouseEvent* ) ;
  virtual void mouseReleaseEvent( QMouseEvent* ) ;
  virtual void mouseMoveEvent( QMouseEvent* ) ;
  virtual void paintEvent( QPaintEvent* ) ;
  virtual void resizeEvent( QResizeEvent* ) ;

 private :
  int minVal ;
  int maxVal ;
  int val1 ;
  int val2 ;
  int startVal1 ;
  int startVal2 ;

  int _lastPos ;
  QPointArray* _triangleVal1 ;
  QPointArray* _triangleVal2 ;
  bool cursorIntriangle1 ;
  bool cursorIntriangle2 ;

} ;

#endif
