
#include <qgradiantzone.h>


QGradiantZone :: QGradiantZone(  int w, int h, int minValue, int maxValue,int typeCurve,
				 int valueFirstCursor,int valueLastCursor,
				 QWidget* parent,const char* name,WFlags f ) : QWidget(parent,name,f)
{
 int dv ;
 int yl,yll ;
 long auxi ;

 setBackgroundMode( NoBackground ) ;
 setMinimumSize(22,22 ) ;
 setGeometry(0,0,w,h) ;
 _minValue = minValue ;
 _maxValue = maxValue ;
 sizeTableau = w - 2*BORDURE ;
 realHeight = h - 2*BORDURE - 1 ;
 if (sizeTableau < 0) sizeTableau = 1 ;
 if (realHeight < 0) realHeight = 1 ;
 nbRect = 3 ;
 state = STATE_ID_NORMAL ;

 //cursors = new QRect[MAX_CURSORS] ;
 tableau = new int [sizeTableau] ;
 //if ((cursors == NULL) || (tableau == NULL))
 if (tableau == NULL)
	{
	 nbRect = 0 ;
	 sizeTableau = 0 ;
	 realHeight = 0 ;
	 return ;
	}

 if (typeCurve ==0) isLinear = true; else isLinear = false ;
 currentRect = -1 ; // not Rect selected
 for(yl=0;yl<MAX_CURSORS;yl++) freeCursor[yl] = true ;
 dv = maxValue - minValue ;
 if (dv == 0) dv = 1 ;
 if (valueFirstCursor < minValue) valueFirstCursor = minValue ;
 if (valueFirstCursor > maxValue) valueFirstCursor = maxValue ;
 auxi = realHeight * (valueFirstCursor - minValue) ;
 auxi /= dv ;
 yl = realHeight - auxi ;
 if (yl<0) yl = 0 ;
 if (yl> realHeight) yl = realHeight  ;
 cursor[0].setRect(-HALF_SIZE_CURSOR,yl-HALF_SIZE_CURSOR+1,SIZE_CURSOR,SIZE_CURSOR) ;
 if (valueLastCursor < minValue) valueLastCursor = minValue ;
 if (valueLastCursor > maxValue) valueLastCursor = maxValue ;
 auxi = realHeight * (valueLastCursor - minValue) ;
 auxi /= dv ;
 yll = realHeight - auxi ;
 if (yll<0) yll = 0 ;
 if (yll> realHeight) yll = realHeight  ;
 cursor[1].setRect(w/2-HALF_SIZE_CURSOR,(yl+yll)/2-HALF_SIZE_CURSOR+1,SIZE_CURSOR,SIZE_CURSOR) ;
 cursor[2].setRect(w-2*BORDURE-HALF_SIZE_CURSOR,yll-HALF_SIZE_CURSOR+1,SIZE_CURSOR,SIZE_CURSOR) ;
 bufferZone.resize(w-2*BORDURE,h-2*BORDURE) ;

 toolmenu = new QPopupMenu(this) ;
 toolmenu->insertItem( "&Create", this,SLOT(createCursor()) ) ;
 toolmenu->insertItem( "&Suppr", this,SLOT(supprCursor()) ) ;

 //bufferZone.fill( white ) ;
 drawCurve() ;
 //bitBlt( this , BORDURE , BORDURE , &bufferZone ) ;
}


QGradiantZone :: ~QGradiantZone()
{
 delete  tableau ;
 //delete  cursors ;
}

int* QGradiantZone :: getValues( int* pt )
{
 *pt = sizeTableau ;
 return tableau ;
}

void QGradiantZone :: setTypeCurve( int tt)
{
 bool temp ;

 if (tt==0) temp = true ; else temp = false ;
 if (temp != isLinear)
	{
	 drawCurve() ;
	 isLinear = temp ;
	 drawCurve() ;
	}
}

void QGradiantZone :: setMinValue(int a)
{
 _minValue = a ;
 drawCurve() ;
}

void QGradiantZone :: setMaxValue(int a)
{
 _maxValue = a ;
 drawCurve() ;
}

void QGradiantZone :: setBlockCursor(int n)
{
 if ((n<=0) || (n>nbRect)) return ;
 n-- ;
 freeCursor[n] = false ;
}

void QGradiantZone :: setFreeCursor(int n)
{
 if ((n<=0) || (n>nbRect)) return ;
 n-- ;
 freeCursor[n] = true ;
}

void QGradiantZone :: drawCurve()
{
 QPainter painterbuffer ;
 //QPainter painter ;
 double t,t2,a2,a3,de,u1,u1p,tv1,tm1,tv2,tm2,aux ;
 long auxi ;
 int i,x1,y1,x1p,y1p,x1pp,y1pp,xl,yl,j,dx,dy ;

 bufferZone.fill( white ) ;
 painterbuffer.begin( &bufferZone ) ;
 //painter.begin( this ) ;
 //painterbuffer.setRasterOp( NotXorROP ) ;
 //painter.setRasterOp( NotXorROP ) ;
 painterbuffer.setPen( black ) ;
 //painter.setPen( black ) ;
 for(i=0;i<nbRect;i++) painterbuffer.drawRect(cursor[i]) ;
 //for(i=0;i<nbRect;i++) painter.drawRect(cursor[i]) ;

 //if (realHeight !=1) cdi = 1.0 / (realHeight-1) ; else cdi = 0.0 ;
 //if (realHeight !=0) cdi = 1.0 / (realHeight) ; else cdi = 0.0 ;
 //cdi *= (_maxValue-_minValue) ;
 xl = 0 ;
 x1 = 0 ;
 if (isLinear)
	{
	 //cout << endl ;
	 for(i=1;i<nbRect;i++)
		{
		 painterbuffer.drawLine(cursor[i-1].center(),cursor[i].center() ) ;
		 //painter.drawLine(cursor[i-1].center(),cursor[i].center() ) ;
		 x1  = (cursor[i-1].center()).x() ;
		 y1  = (cursor[i-1].center()).y() ;
		 x1p = (cursor[i].center()).x() ;
		 y1p = (cursor[i].center()).y() ;
		 dx  = x1p - x1 ;
		 if (dx != 0) de  = 1.0/dx ; else de = 0.0 ;
		 dy  = y1p - y1 ;
		 //cout << "x1 = " << x1 << " x1p = " << x1p << " dx = " << dx  << endl ;
		 //cout << "y1 = " << y1 << " y1p = " << y1p << " dy = " << dy  << endl ;
		 //cout << endl ;
		 //xl = x1 ;
		 for(j=0;j<dx;j++,xl++)
			{
			 t  = j*de ;
			 yl = (int) (y1 + t * dy) ;
			 if (yl<0) yl = 0 ;
			 if (yl>realHeight) yl = realHeight ;
			 auxi = _maxValue * (realHeight - yl) + yl * _minValue ;
			 tableau[xl] = (int) auxi / realHeight ;
			 //cout << "(" << xl << "," << tableau[xl] << ")"  ;
			}
		}
	 y1p = (cursor[nbRect-1].center()).y() ;
	 //if (y1p<0) y1p = 0 ;
	 //if (y1p>realHeight) y1p = realHeight ;
	 auxi = _maxValue * (realHeight - y1p) + y1p * _minValue ;
	 tableau[xl] = (int) auxi / realHeight ;
	 //cout << " y1p = " << y1p << endl ;
	 //cout << " _maxValue = " << _maxValue << endl ;
	 //cout << "(*" << xl << "," << tableau[xl] << "*)"  ;
	 //cout << endl ;
	}
	else
	{
	 // smooth
	 // la fonction est cubique par morceaux. Except au ppremier et dernier curseurs, je
	 // prend la moyenne des taux de varaitions  chaque curseur.
	 //cout << endl ;
	 y1  = (cursor[0].center()).y() ;
	 x1p = (cursor[1].center()).x() ;
	 y1p = (cursor[1].center()).y() ;
	 dx  = x1p - x1 ;
	 tv1 = y1p - y1 ;
	 if (dx != 0) de  = 1.0/dx ; else de = 0.0 ;
	 tv1 *= de ;
	 tm1 = tv1 ;
	 dy  = y1p - y1 ;
	 i = 2 ;
	 while (i<nbRect)
		{
		 x1pp = (cursor[i].center()).x() ;
		 y1pp = (cursor[i].center()).y() ;
		 aux  = 1.0 / (x1pp - x1p) ;
		 tv2  = (y1pp - y1p) * aux ;
		 tm2  = (tv1+tv2)*0.5 ;
		 u1   = dx * tm1 ;
		 u1p  = dx * tm2 ;
		 //xl = x1 ;
		 for(j=0;j<dx;j++,xl++)
			{
			 t  = j*de ;
			 t2 = t*t ;
			 a2 = 3.0*dy - u1 - u1 - u1p ;
			 a3 = u1 + u1p - dy - dy ;
			 yl = (int) (y1 + u1 * t + a2 * t2 + a3 * t * t2) ;
			 if (yl<0) yl = 0 ;
			 if (yl>=realHeight) yl = realHeight-1 ;
			 painterbuffer.drawPoint(xl,yl) ;
			 //painter.drawPoint(xl,yl) ;
			 auxi = _maxValue * (realHeight - yl) + yl * _minValue ;
			 tableau[xl] = (int) auxi / realHeight ;
			 //cout << "(" << xl << "," << tableau[xl] << ")" ;
			}
		 // prparation de la boucle suivante
		 x1  = x1p ;
		 y1  = y1p ;
		 x1p = x1pp ;
		 y1p = y1pp ;
		 tm1 = tm2 ;
		 tv1 = tv2 ;
		 dx  = x1p - x1 ;
		 if (dx != 0) de  = 1.0/dx ;
		 dy  = y1p - y1 ;
		 i++ ;
		}

	 y1pp = (cursor[nbRect-1].center()).y() ;
	 u1   = dx * tm1 ;
	 u1p  = y1pp - y1p ;
	 //xl = x1 ;
	 for(j=0;j<dx;j++,xl++)
		{
		 t  = j*de ;
		 t2 = t*t ;
		 a2 = 3.0*dy - u1 - u1 - u1p ;
		 a3 = u1 + u1p - dy - dy ;
		 yl = (int) (y1 + u1 * t + a2 * t2 + a3 * t * t2) ;
		 if (yl<0) yl = 0 ;
		 if (yl>=realHeight) yl = realHeight-1 ;
		 painterbuffer.drawPoint(xl,yl) ;
		 //painter.drawPoint(xl,yl) ;
		 auxi = _maxValue * (realHeight - yl) + yl * _minValue ;
		 tableau[xl] = (int) auxi / realHeight ;
		 //cout << "((" << xl << "," << tableau[xl] << "))" ;
		}
	 auxi = _maxValue * (realHeight - y1pp) + y1pp * _minValue ;
	 tableau[xl] = (int) auxi / realHeight ;
	 //cout << "(" << xl << "," << tableau[xl] << ")" ;
	 //cout << endl ;
	}
 emit valuesChanged( sizeTableau,tableau ) ;

 painterbuffer.end() ;
 //painter.end() ;
 bitBlt( this , BORDURE , BORDURE , &bufferZone ) ;
}

void QGradiantZone :: createCursor()
{
 QApplication::setOverrideCursor( QCursor(Qt::CrossCursor) ) ;
 state = STATE_ID_CREATE ;
}

void QGradiantZone :: supprCursor()
{
 QApplication::setOverrideCursor( QCursor(Qt::ForbiddenCursor) ) ;
 state = STATE_ID_SUPPR ;
}


void QGradiantZone :: mousePressEvent( QMouseEvent* e )
{
 int i,xl, yl, j , il=-1 ;
 bool okCreate, okSuppr ;

 xl = e->x() - BORDURE ;
 yl = e->y() - BORDURE ;
 currentRect = -1 ;

 if ( e->button() == LeftButton )
	{
	 if (state == STATE_ID_NORMAL)
		{
		 lastPosX = xl ;
		 lastPosY = yl ;
		 for(i=0;i<nbRect;i++) if (cursor[i].contains(lastPosX,lastPosY)) currentRect = i ;
		}
	 if (state == STATE_ID_CREATE)
		{
		 okCreate = true ;
		 for(i=0;i<nbRect;i++) if ((cursor[i].center()).x() == xl) okCreate = false ;
		 if ((xl<0) || (xl>sizeTableau) || (yl<0) || (yl>=realHeight)) okCreate = false ;
		 if (nbRect == MAX_CURSORS) okCreate = false ;
		 if (okCreate)
			{
			 drawCurve() ; // pour effacer les anciens traits
			 i=0 ;
			 while ((cursor[i].center()).x() < xl) i++ ;
			 for(j=nbRect;i<j;j--) cursor[j] = cursor[j-1] ;
			 for(j=nbRect;i<j;j--) freeCursor[j] = freeCursor[j-1] ;
			 cursor[i].setLeft(xl-SIZE_CURSOR/2) ;
			 cursor[i].setTop(yl-SIZE_CURSOR/2) ;
			 cursor[i].setWidth(SIZE_CURSOR) ;
			 cursor[i].setHeight(SIZE_CURSOR) ;
			 freeCursor[i] = true ;
			 nbRect++ ;
			 drawCurve() ;
			}
		 QApplication::restoreOverrideCursor() ;
		 state = STATE_ID_NORMAL ;
		}
	 if (state == STATE_ID_SUPPR)
		{
		 okSuppr = false ;
		 j = nbRect-1 ;
		 for(i=1;i<j;i++)
			{
			 if (cursor[i].contains(xl,yl))
				{
				 okSuppr = true ;
				 il = i ;
				}
			}
		 if (okSuppr)
			{
			 drawCurve() ; // pour effacer les anciens traits
			 for(i=il;i<j;i++) cursor[i] = cursor[i+1] ;
			 for(i=il;i<j;i++) freeCursor[i] = freeCursor[i+1] ;
			 nbRect = j ;
			 drawCurve() ;
			}
		 QApplication::restoreOverrideCursor() ;
		 state = STATE_ID_NORMAL ;
		}
	}
 if ( e->button() == RightButton ) toolmenu->popup(QCursor::pos()) ;

}

void QGradiantZone :: mouseMoveEvent( QMouseEvent* e)
{
 //QPoint aux ;
 int dx, dy, newX, newY,cbeforeX,cnextX ;

if (( e->state() == LeftButton ) && (currentRect >= 0) && (freeCursor[currentRect]))
	{
	 dx = e->x() - lastPosX - BORDURE ;
	 dy = e->y() - lastPosY - BORDURE ;
	 newX = (cursor[currentRect].center()).x() + dx ;
	 newY = (cursor[currentRect].center()).y() + dy ;
	 //aux = e->pos() - lastPos - omega ;
	 drawCurve() ; // pour effacer les anciens traits
	 if ((currentRect == 0) || (currentRect == nbRect-1))
		{
		 if ((newY >= 0) && (newY <= realHeight))
			cursor[currentRect].moveBy(0,dy) ;
		}
		else
		{
		 cbeforeX = (cursor[currentRect-1].center()).x() ;
		 cnextX = (cursor[currentRect+1].center()).x() ;
		 if ((newY >= 0) && (newY <= realHeight) && (cbeforeX < newX) && (newX < cnextX))
			 cursor[currentRect].moveBy(dx,dy) ;
		}
	 drawCurve() ;
	 lastPosX += dx ;
	 lastPosY += dy ;
	}
}

/*
void QGradiantZone :: mouseReleaseEvent( QMouseEvent* e )
{

}
*/


void QGradiantZone :: keyPressEvent( QKeyEvent* e)
{
 int rep ;

 rep = e->key() ;
 if (rep == Qt::Key_L) setTypeCurve(0) ;
 if (rep == Qt::Key_S) setTypeCurve(1) ;
 if (rep == Qt::Key_A) setBlockCursor(2) ;
if (rep == Qt::Key_B) setFreeCursor(2) ;
}


void QGradiantZone :: paintEvent( QPaintEvent* )
{
 //bufferZone.fill( white ) ;
 //drawCurve() ;
 bitBlt( this , BORDURE , BORDURE , &bufferZone ) ;
}

/*
void QGradiantZone :: resizeEvent( QResizeEvent* )
{
}
*/



