#ifndef QGRADIANTZONE_H
#define QGRADIANTZONE_H

using namespace std ;
#include <iostream>
#include <cmath>

#include <qapplication.h>
#include <qwidget.h>
#include <qpainter.h>
#include <qpixmap.h>
#include <qrect.h>
#include <qpopupmenu.h>
#include <qcursor.h>

#define MAX_CURSORS 16
#define BORDURE 0
#define SIZE_CURSOR 10
#define HALF_SIZE_CURSOR SIZE_CURSOR/2

enum StateIDs
{
 STATE_ID_NORMAL,
 STATE_ID_CREATE,
 STATE_ID_SUPPR,
} ;

class QGradiantZone : public QWidget
{
  Q_OBJECT

 public :
 // constructeur
  QGradiantZone( int width, int height, int minValue=0, int maxValue=100,int typeCurve=0,
  		int valueFirstCursor=0,int valueLastCursor=0, QWidget* parent=0,const char* name=0,WFlags f=0 ) ;
  virtual ~QGradiantZone() ;
  int* getValues( int* ) ;
  void setTypeCurve( int ) ;
  void setMinValue(int) ;
  void setMaxValue(int) ;
  void setBlockCursor(int n) ; // n reprsente le numro du curseur (n >= 1)
  void setFreeCursor(int n) ; // n reprsente le numro du curseur (n >= 1)

 public slots :
  void createCursor() ;
  void supprCursor() ;

 signals :
  void valuesChanged( int,int* ) ;

 protected :
  virtual void mousePressEvent( QMouseEvent* ) ;
  //virtual void mouseReleaseEvent( QMouseEvent* ) ;
  virtual void mouseMoveEvent( QMouseEvent* ) ;
  virtual void keyPressEvent( QKeyEvent* ) ;
  virtual void paintEvent( QPaintEvent* ) ;
  //virtual void resizeEvent( QResizeEvent* ) ;

 private :

  void drawCurve() ;

  QPixmap bufferZone ;
  //QPoint lastPos, omega ;
  QRect cursor[MAX_CURSORS] ;
  int sizeTableau, nbRect, currentRect, realHeight, lastPosX, lastPosY, state, _minValue, _maxValue ;
  int* tableau ;
  QPopupMenu* toolmenu ;
  bool  freeCursor[MAX_CURSORS] ;
  bool isLinear ;


} ;

#endif
