
#include <qlabel.h>
#include <qcombobox.h>
#include <qcheckbox.h>
#include <qpainter.h>
#include <qpixmap.h>
#include <qlineedit.h>

#include "constants.h"
#include "repartition.h"
#include "qdoubleslider.h"
#include <qgradiantzone.h>

repartition ::repartition (QTabWidget* parent=0,const char* name=0, WFlags f=0 ) : QWidget(parent,name,f)
{
 //_bufferRepartition.resize(SIZE_IMAGE_REPARTITION_X,SIZE_IMAGE_REPARTITION_Y) ;
 _bufferRepartition = new QPixmap(SIZE_IMAGE_REPARTITION_X,SIZE_IMAGE_REPARTITION_Y) ;

    textLabel2 = new QLabel( this, "textLabel2" );
    textLabel2->setGeometry( QRect( 150, 390, 31, 20 ) );

    textLabel1 = new QLabel( this, "textLabel1" );
    textLabel1->setGeometry( QRect( 10, 390, 25, 20 ) );

    lineEdit3 = new QLineEdit( this, "lineEdit3" );
    lineEdit3->setGeometry( QRect( 9, 113, 70, 24 ) );

    lineEdit4 = new QLineEdit( this, "lineEdit4" );
    lineEdit4->setGeometry( QRect( 199, 113, 70, 24 ) );
    /*
    frame14 = new QFrame( tab, "frame14" );
    frame14->setGeometry( QRect( 10, 170, 40, 170 ) );
    frame14->setFrameShape( QFrame::StyledPanel );
    frame14->setFrameShadow( QFrame::Raised );*/
    _imagePalette = new QPixmap(40,170) ;
    _imagePalette->fill( white ) ;

    comboBox3 = new QComboBox( FALSE, this, "comboBox3" );
    comboBox3->setGeometry( QRect( 40, 380, 90, 30 ) );

    comboBox4 = new QComboBox( FALSE, this, "comboBox4" );
    comboBox4->setGeometry( QRect( 180, 380, 90, 30 ) );

    /*
    frame13 = new QFrame( tab, "frame13" );
    frame13->setGeometry( QRect( 60, 170, 210, 170 ) );
    frame13->setFrameShape( QFrame::StyledPanel );
    frame13->setFrameShadow( QFrame::Raised );*/
    _gzColor = new QGradiantZone(210,170,MIN_VALUE_GRADIANT_ZONE,MAX_VALUE_GRADIANT_ZONE,
    				0,MIN_VALUE_GRADIANT_ZONE,MAX_VALUE_GRADIANT_ZONE,this, "_gzColor",0) ;
    _gzColor->setGeometry( QRect( 60, 170, 210, 170 ) );

    checkBox10 = new QCheckBox( this, "checkBox10" );
    checkBox10->setGeometry( QRect( 60, 350, 110, 22 ) );

    // initialisation
    lineEdit3->setText(  "0"  );
    lineEdit4->setText(  "0"  );
    textLabel2->setText( "high"  );
    textLabel1->setText( "low"  );
    comboBox3->clear(); // low
    comboBox3->insertItem( "satured"  );
    comboBox3->insertItem( "modulo"  );
    comboBox3->insertItem( "cycle"  );
    comboBox3->insertItem( "dark"  );
    comboBox3->insertItem( "bright"  );
    comboBox4->clear();
    comboBox4->insertItem( "satured"  );
    comboBox4->insertItem( "modulo"  );
    comboBox4->insertItem( "cycle"  );
    comboBox4->insertItem( "dark"  );
    comboBox4->insertItem( "bright"  );
    checkBox10->setText( "smooth curve"  );
    mini = 0 ;
    maxi = 0 ;

    _dsRepartition = new QDoubleSlider(0,SIZE_IMAGE_REPARTITION_X-1,
    				       0,SIZE_IMAGE_REPARTITION_X-1,
				       this,"_dsRepartition",0) ;
    _dsRepartition->setGeometry( QRect( 1, 143, 275, 24 ) );


 QObject::connect( _dsRepartition,SIGNAL(valuesChanged(int,int)),this,
 			SLOT(slotDrawRepartitionZoomed(int,int)) ) ;
 QObject::connect( checkBox10,SIGNAL(clicked()),this, SLOT(slotSmoothCurve()) ) ;
 QObject::connect( checkBox10,SIGNAL(clicked()),this, SLOT(slotParameterColorationChanged())) ;
 QObject::connect( lineEdit3,SIGNAL(textChanged(const QString&)),this,SLOT(slotParameterColorationChanged()) ) ;
 QObject::connect( lineEdit4,SIGNAL(textChanged(const QString&)),this,SLOT(slotParameterColorationChanged()) ) ;
 QObject::connect( comboBox3,SIGNAL(highlighted(int)),this,SLOT(slotParameterColorationChanged()) ) ;
 QObject::connect( comboBox4,SIGNAL(highlighted(int)),this,SLOT(slotParameterColorationChanged()) ) ;
}

repartition :: ~repartition()
{
 if ( _bufferRepartition != NULL) delete _bufferRepartition ;
 if ( _imagePalette != NULL) delete _imagePalette ;
}

void repartition :: setMinMax(int m,int M)
{
 QString nb ;

 mini = m ;
 maxi = M ;
 miniZoomed = m ;
 maxiZoomed = M ;
 lineEdit3->setText( nb.setNum(m) );
 lineEdit4->setText( nb.setNum(M) );
 _dsRepartition->setValues(0,SIZE_IMAGE_REPARTITION_X-1) ;
}

void repartition :: drawRepartition(int* t)
{
 QPainter windowpainter ;
 QPainter bufferpainter ;
 int maximum=0,i,h ;

 for(i=0;i<SIZE_IMAGE_REPARTITION_X;i++)
	if (t[i]>maximum) maximum = t[i] ;
 if (maximum==0) { maximum = 1 ; }

 windowpainter.begin( this ) ;
 bufferpainter.begin( _bufferRepartition ) ;

 for(i=0;i<SIZE_IMAGE_REPARTITION_X;i++)
	{
	 windowpainter.setPen( black ) ;
	 bufferpainter.setPen( black ) ;
	 h = (t[i]*SIZE_IMAGE_REPARTITION_Y)/maximum ;
	 windowpainter.drawLine(9+i,3+SIZE_IMAGE_REPARTITION_Y,9+i,3+SIZE_IMAGE_REPARTITION_Y-h) ;
	 bufferpainter.drawLine(i,SIZE_IMAGE_REPARTITION_Y,i,SIZE_IMAGE_REPARTITION_Y-h) ;
	 windowpainter.setPen( white ) ;
	 bufferpainter.setPen( white ) ;
	 windowpainter.drawLine(9+i,3+SIZE_IMAGE_REPARTITION_Y-h,9+i,3 ) ;
	 bufferpainter.drawLine(i,SIZE_IMAGE_REPARTITION_Y-h-1,i,0 ) ;
	}
 windowpainter.end() ;
 bufferpainter.end() ;
}

void repartition :: slotDrawRepartitionZoomed(int ml,int Ml)
{
 QString nb ;
 int di ;

 di = maxi - mini ;
 miniZoomed = mini + (ml * di ) / SIZE_IMAGE_REPARTITION_X ;
 maxiZoomed = mini + (Ml * di ) / SIZE_IMAGE_REPARTITION_X ;
 lineEdit3->setText( nb.setNum(miniZoomed) );
 lineEdit4->setText( nb.setNum(maxiZoomed) );
 emit signalDrawRepartitionZoomed(miniZoomed,maxiZoomed) ;
}

void repartition :: getParameterColoration(parameterColoration* p)
{
 int aux ;

 p->minZoomed = miniZoomed ;
 p->maxZoomed = maxiZoomed ;
 p->low = comboBox3->currentItem() ;
 p->high = comboBox4->currentItem() ;
 p->table = _gzColor->getValues(&aux) ;
 p->sizeTable = aux ;
 //p->minValue = MIN_VALUE_GRADIANT_ZONE ;
 p->maxValue = MAX_VALUE_GRADIANT_ZONE ;
}

void repartition :: drawPalette(paletteRGB* p)
{
 QPainter bufferpainter ;
 bufferpainter.begin( _imagePalette ) ;
 int i,r,g,b,nb ;
 unsigned int c ;

 nb = p->nbColors ;

 for(i=1;i<=IMAGE_PALETTE_HEIGHT;i++)
	{
	 c = p->colors[(i*nb)/IMAGE_PALETTE_HEIGHT] ;
	 r = c & MASK_COLOR ;
	 g = (c>> 8) & MASK_COLOR ;
	 b = (c>> 16) & MASK_COLOR ;
	 bufferpainter.setPen( QColor(r,g,b) ) ;
	 bufferpainter.drawLine(0,IMAGE_PALETTE_HEIGHT-i,IMAGE_PALETTE_HEIGHT,IMAGE_PALETTE_HEIGHT-i) ;
	}
 bufferpainter.end() ;
 bitBlt( this , 10 , 170 , _imagePalette ) ;
}

void repartition :: slotSmoothCurve()
{
 if (checkBox10->isChecked()) _gzColor->setTypeCurve(1) ; else _gzColor->setTypeCurve(0) ;
}

void repartition :: slotParameterColorationChanged()
{
 emit signalParameterColorationChanged() ;
}

void repartition :: paintEvent( QPaintEvent* event )
{
 bitBlt( this , 9 , 3 , _bufferRepartition ) ;
 bitBlt( this , 10 , 170 , _imagePalette ) ;
}





